var arrHistoryParam = {
//    Главное меню
    "WelcomeView": {
        func: showWelcomeView
    },

//    Остатки
    "StoreListView": {
        func: showStoreListView
    },

//    Справочник товаров
    "ProductsListView": {
        func: showProductsListView
    },

//    Контрагенты
    "PersonsListView": {
        func: showPersonsListView
    },

//    Запрос номенклатуры
    "QueryApView": {
        func: showQueryApView
    },

//    Накладные
    "EgaisTtnListView": {
        func: showEgaisTtnListView
    },
    "EgaisTtnInfoView": {
        func: showEgaisTtnInfoView
    },
    "WaybillCreateFormView": {
        func: showWaybillCreateFormView
    },

//    Акты
    "ActListView": {
        func: showActListView
    },

    "EgaisCreateActBalanceView": {
        func: showEgaisCreateActBalanceView
    },
    "EgaisCreateActWrtOfView": {
        func: showEgaisCreateActWrtOfView
    },

    "EgaisCreateActBalanceSRView": {
        func: showEgaisCreateActBalanceSRView
    },

//    Журнал чеков
    "ChecksListView": {
        func: showChecksListView
    },
    "SettingsView": {
        func: showSettingsView
    },

//    Сетевые настройки
    "SettingsNetwork": {
        func: showSettingsNetwork
    },
    "SettingsUtm": {
        func: showSettingsUtm
    },
    "SettingsCash": {
        func: showSettingsCash
    },
    "TimeZone": {
        func: showChangeTimeZone
    },
    "SystemLogs": {
        func: showSystemLogs
    },
    "CheckIn": {
        func: showCheckIn
    },
    "Skin": {
        func: showSkin
    }
};

var viewHandler = function(view, param){
    var arg;
    var func = arrHistoryParam[view].func;

    if("param" in arrHistoryParam[view]){
        arg = arrHistoryParam[view].param ? arrHistoryParam[view].param : null;
    } else {
        arg = param;
    }

    func(arg);
};

var HistoryApi = function(){
    var o = this;
    var nav = $(".navigation-history");

    this.setView = function(view, param) {
        if(window.history.state && window.history.state.handler && window.history.state.handler == view) {
            window.history.replaceState({handler: view, historyParam: param}, null);
        } else {
            window.history.pushState({handler: view, historyParam: param}, null);
        }
    }

    this.init = function(){
//        nav.on("click", function(){
//            var view = $(this).data('view-name');
//            o.setView(view);
//        });
        $("body").on('click', function(e){
            var target  = e.target;

            var parentNode = target.parentNode;
            while (target != parentNode.parentNode) {
                if($(target).hasClass("navigation-history")) {
                    var view = target.getAttribute('data-view-name');
                    o.setView(view);
                    break;
                }
                target = target.parentNode;
            }
        });

        if(!window.history.state) {
            o.setView("WelcomeView");
        }
    }

    this.init();
}

var api;

$(window).load(function(){
    if (window.history.pushState) {
        api = new HistoryApi();
        if (window.history.state && window.history.state.handler) {
            setTimeout(function(){
                viewHandler(window.history.state.handler, window.history.state.historyParam);
            }, 500);
        }

        window.addEventListener('popstate', function (e) {
            if (e.state && (typeof e.state.handler !== 'undefined') ) {
                viewHandler(e.state.handler, e.state.historyParam);
            }
        });
    }
});