function toolbar_formA() {
    var grid = $("#actPositionsListGrid").data("kendoGrid");
    var row = grid.select();
    var dataItem = grid.dataItem(row);
    if(!dataItem) return;

    showActInfoFormADialogView(dataItem);
}

function toolbar_marks() {
    var grid = $("#actPositionsListGrid").data("kendoGrid");
    var row = grid.select();
    var dataItem = grid.dataItem(row);
    if(!dataItem) return;

    showMarksDialogView(dataItem.id);
}

var getActInfoTypeText = function (status) {
    return (status == ACT_TYPE_CONFIRMED) ? "подтверждения" :
        (status == ACT_TYPE_REJECTION) ? "отказа" :
            (status == ACT_TYPE_DIFFERENCE) ? "расхождения" :
                (status == ACT_TYPE_BALANCE) ? "постановки на баланс" :
                    (status == ACT_TYPE_WRTOF) ? "списания" :
                        (status == ACT_TYPE_BALANCE_SR) ? "постановки на баланс в торговом зале" :
                            (status == ACT_TYPE_WRTOF_SR) ? "списания из торгового зала" :
                                (status == ACT_TYPE_TRANSFER) ? "передачи в торговый зал" :
                                    (status == ACT_TYPE_TRANSFER_TO_STOCK) ? "передачи на склад" : "";
}

var showActInfoView = function(obj) {
    var actId = obj.id;
    var actType = obj.id_type;
    var actNum = obj.act_num;
    var actDate =  kendo.toString(new Date(obj.act_date), "dd.MM.yyyy");

    var INFO_ICON = "info.jpg";
    var MARKS_ICON = "stamp.png";

    var egaisActInfoView = new kendo.View($('#actInfoViewTemplate').html());
    layout.showIn("#content", egaisActInfoView);

    $(".wrapGrid").hide();

    viewModel.currentActTypeId  = " " + getActInfoTypeText(actType);
    viewModel.currentActNumber = actNum ? " № " + actNum : " № (без номера)";
    kendo.bind($("span"), viewModel);

    $("#currentActDt").html(" от ");
    $("#currentActDt").append(actDate);

    $("#refreshButton").kendoButton({
        icon: "refresh",
        click: function(){
            reloadPositionsList();
        }
    });

    function toolbarTemplate() {
        if(actType == 4)
            return '<span>Список позиций:</span>'+
                '<button id="btnShowInfoFormA" type="button" class="k-button k-button-toolbar pull-right" title="Справка А" onclick="toolbar_formA()">' +
                '<img class="k-image" width="16" height="16" src="assets/icons/pays/' + INFO_ICON + '"/>' +
                '</button>' +
                '<button id="btnShowStamp" type="button" class="k-button k-button-toolbar pull-right" title="Федеральные марки" onclick="toolbar_marks()">' +
                '<img class="k-image" width="16" height="16" src="assets/icons/pays/' + MARKS_ICON + '"/>' +
                '</button>';
        return '<span>Список позиций:</span>';
    }

    var actPositionsListGrid = $("#actPositionsListGrid").kendoGrid({
        dataSource  : {
            data: [],
            schema: {
                model: {
                    fields: {
                        identity: { type: "number" },
                        qty: { type: "number" },
                        capacity: { type: "number" }
                    }
                }
            }
        },
        filterable: {
            extra: false,
            messages: {
                and: "и",
                or: "или",
                filter: "Фильтр",
                clear: "Очистить",
                info: "Фильтр по значению:",
                selectedItemsFormat: "Выбрано {0} элементов",
                checkAll: "Выбрать Всё"
            },
            operators: {
                string: {
                    contains: "Содержит",
                    eq: "Равно",
                    neq: "Не равно",
                    doesnotcontain: "Не содержит",
                    startswith: "Начинается на",
                    endswith: "Заканчивается на",
                    isempty: "Пустые",
                    isnotempty: "Не пустые"
                },
                number: {
                    eq: "=",
                    neq: "!=",
                    gt: ">",
                    lt: "<",
                    gte: ">=",
                    lte: "<=",
                    isnull: "Null",
                    isnotnull: "!Null"
                },
                date: {
                    gte: "после или равна",
                    gt: "после",
                    lte: "до или равна",
                    lt: "до"
                }
            }
        },
        resizable: true,
        sortable: true,
        reorderable: true,
        selectable: "row",
        pageable: {
            pageSize: 20,
            pageSizes: true
        },
        toolbar: [
            { template: kendo.template(toolbarTemplate()) }
        ],
        columns: [
            { field: "identity", title: "№", width: 50, filterable: false },
            { field: "product_v_code", title: "Группа", width: 100 },
            { field: "name", title: "Наименование", attributes:{ "class": "table-cell" }, width: 250 },
            { field: "capacity", title: "Объем", width: 70, filterable: false,
                template: function(dataItem) {
                    return dataItem.capacity == 0 ? "не фас." :
                        (kendo.toString(dataItem.capacity / 1000, "n2") + " л");
                }
            },
            { field: "alc_code", title: "Код ЕГАИС", attributes:{ "class": "table-cell" }, width: 180 },
            { field: "ean", title: "Штрихкод", attributes:{ "class": "table-cell" }, width: 110 },
            { field: "qty", title: "Кол.", width: 80, filterable: false,
                template: function(dataItem) {
                    return dataItem.capacity == 0 ? (kendo.toString(dataItem.qty / 10000, "n3") + " дал") :
                        dataItem.qty;
                }
            },

            { field: "producer", title: "Производитель", attributes:{ "class": "table-cell" }, width: 180 },
            { field: "producer_address", title: "Адрес производителя", width: 200, attributes:{ "class": "table-cell" } },
            { field: "importer", title: "Импортер", attributes:{ "class": "table-cell" }, width: 180 },
            { field: "importer_address", title: "Адрес импортера", width: 200, attributes:{ "class": "table-cell" } }
        ],
        dataBinding: function() {
            this.thead.kendoTooltip({
                callout:false,
                position: "top",
                filter: "th",
                content: function (e) {
                    return $(e.target).attr("data-title");
                }
            });
        }
    }).data("kendoGrid");
    bindWinSet('#ActInfoView', "#actPositionsListGrid", "cookiesActPositionsListGrid");

    $("#actPositionsListGrid").kendoTooltip({
        filter: "td.table-cell:not(:empty)",
        position: "right",
        animation: {
            open: {
                effects: "fade:in",
                duration: 200
            }
        },
        showAfter: 400,
        content: function(e) {
            var target = e.target;
            var content = target.text();
            return content;
        }
    }).data("kendoTooltip");

    $("#actPositionsListGrid").kendoTooltip({
        filter: ".k-button-toolbar",
        callout: false,
        position: "top"
    });

    reloadPositionsList();

    function reloadPositionsList(){
        $("#refreshButton").button('loading');
        clearInterval(timerId);
        timerId = dotted();

        showProcessAlert("Загрузка данных");
        try {
            var obj = {
                id: actId
            };
            channel.objects.utm_server.getActPositions(obj, function (res) {
                hideAlerts();
                clearInterval(timerId);
                $("#refreshButton").button('reset');

                if(res.code == 0) {
                    if(res.data.length != 0) {
                        $(".wrapGrid").show();
                        actPositionsListGrid.dataSource.data(res.data);
                        actPositionsListGrid.refresh();
                    }
                } else {
                    showErrorMessage(res.message);
                }
            });
        } catch(e) {
            showErrorAlert("<strong>Соединение потеряно или истекло время сессии, попробуйте обновить страницу</strong>");
            clearInterval(timerId);
            $("#refreshButton").button('reset');
        }
    }
}

//окно для показа фед. марок
//--------------------------
var dialogMarks;
var marksListGrid;

$(window).load(function() {
    dialogMarks = $("#dialogMarks").kendoWindow({
        actions: [ "Maximize", "Close" ],
        title: "Федеральные марки",
        visible: false,
        scrollable: false,
        modal: true,
        pinned: true,
        height: 410,
        resize: function() {
            marksListGrid.setOptions({
                height: $("#dialogMarks").outerHeight() - 70
            });
        }
    }).data("kendoWindow");

    $('#dialogMarks').keydown(function(eventObject){
        if(eventObject.which == '27')
            dialogMarks.close();
    });

    $(window).resize(function(){
        var width;
        if (window.innerWidth < '768')
            width = 320;
        else
            width = 500;


        dialogMarks.setOptions({
            width: width
        });
        dialogMarks.center();
    });
    $(window).resize();
});

var showMarksDialogView = function(id) {
    dialogMarks.content(kendo.template($("#contentDialogMarksTemplate").html()));
    dialogMarks.center().open();

    var viewModelDialogMarks = kendo.observable({
        cancel: function () {
            dialogMarks.close();
        }
    });
    kendo.bind($("#dialogMarks"), viewModelDialogMarks);

    stampsListGrid = $("#stampsListGrid").kendoGrid({
        dataSource: [],
        filterable: false,
        resizable: true,
        height: $("#dialogMarks").outerHeight() - 70,
        sortable: false,
        selectable: "row",
        columns: [
            { field: "identity", title: "№", width: 40, filterable: false,
                template: function(dataItem){
                    var ds = $("#stampsListGrid").data("kendoGrid").dataSource,
                        index = ds.indexOf( dataItem );
                    return index + 1;
                }
            },

            { field: "fmark", title: "Марка", attributes:{ "class": "table-cell" }, width: 230 }
        ]
    }).data("kendoGrid");

    try {
        var posId = {
            id: id
        };
        channel.objects.utm_server.getPosFmarks(posId, function (res) {
            if (res.code == 0) {
                var data = res.data;

                var grid = $("#stampsListGrid").data("kendoGrid");
                grid.dataSource.data(data);
                grid.refresh();
            }
        });
    } catch (e) {}
}

//информация из справки А
//------------------------
var dialogActInfoFormA;

$(window).load(function() {
    dialogActInfoFormA = $("#dialogActInfoFormA").kendoWindow({
        actions: [ "Maximize", "Close" ],
        title: "Информация из справки А",
        visible: false,
        resizable: false,
        scrollable: false,
        modal: true,
        pinned: true,
        width: 500
    }).data("kendoWindow");

    $('#dialogActInfoFormA').keydown(function(eventObject){
        if(eventObject.which == '27')
            dialogActInfoFormA.close();
    });

    $(window).resize(function(){
        var width;

        if (window.innerWidth < '768')
            width = 280;
        else
            width = 500;

        dialogActInfoFormA.setOptions({
            width: width
        });
        dialogActInfoFormA.center();
    });
    $(window).resize();
});

var showActInfoFormADialogView = function (data) {
    dialogActInfoFormA.content( kendo.template($("#contentDialogActInfoFormATemplate").html()) );
    dialogActInfoFormA.center().open();

    var viewModelDialogActInfoFormA = kendo.observable({
        formAQuantity: data.form_a_qty,
        formABottlingDate: data.form_a_bottling_date ? kendo.toString(new Date(data.form_a_bottling_date), "dd.MM.yyyy") : "",
        formATtnNumber: data.form_a_ttn_number,
        formATtnDate: data.form_a_ttn_date ? kendo.toString(new Date(data.form_a_ttn_date), "dd.MM.yyyy") : "",
        formAEgaisFixNumber: data.form_a_egais_fix_number,
        formAEgaisFixDate: data.form_a_egais_fix_date ? kendo.toString(new Date(data.form_a_egais_fix_date), "dd.MM.yyyy") : "",
        cancel: function () {
            dialogActInfoFormA.close();
        }
    });
    kendo.bind($("#dialogActInfoFormA"), viewModelDialogActInfoFormA);
};