//--------- Тип ----------
var ACT_TYPE_CONFIRMED = 1,
    ACT_TYPE_REJECTION = 2,
    ACT_TYPE_DIFFERENCE = 3,
    ACT_TYPE_BALANCE = 4,
    ACT_TYPE_WRTOF = 5,
    ACT_TYPE_BALANCE_SR = 6,
    ACT_TYPE_WRTOF_SR = 7,
    ACT_TYPE_TRANSFER = 8,
    ACT_TYPE_TRANSFER_TO_STOCK = 9;

var getActTypeClass = function (status) {
    return (status == ACT_TYPE_CONFIRMED) ? "csAcceptBoxLabel" :
        (status == ACT_TYPE_REJECTION) ? "csErrorBoxLabel" :
            (status == ACT_TYPE_DIFFERENCE) ? "csWaitBoxLabel" :
                (status == ACT_TYPE_BALANCE) ? "csReceivedBoxLabel" :
                    (status == ACT_TYPE_WRTOF) ? "csSentBoxLabel" :
                        (status == ACT_TYPE_BALANCE_SR) ? "csBalanceSRBoxLabel" :
                            (status == ACT_TYPE_WRTOF_SR) ? "csWrtOfSRBoxLabel" :
                                (status == ACT_TYPE_TRANSFER) ? "csTransferSRBoxLabel" :
                                    (status == ACT_TYPE_TRANSFER_TO_STOCK) ? "csNotCheckedBoxLabel" : "";

}

var getActTypeText = function (status) {
    return (status == ACT_TYPE_CONFIRMED) ? "Подтверждение" :
        (status == ACT_TYPE_REJECTION) ? "Отказ" :
            (status == ACT_TYPE_DIFFERENCE) ? "Расхождение" :
                (status == ACT_TYPE_BALANCE) ? "Постановка на баланс" :
                    (status == ACT_TYPE_WRTOF) ? "Списание" :
                        (status == ACT_TYPE_BALANCE_SR) ? "Постановка на баланс в торговом зале" :
                            (status == ACT_TYPE_WRTOF_SR) ? "Списание из торгового зала" :
                                (status == ACT_TYPE_TRANSFER) ? "Передача в торговый зал" :
                                    (status == ACT_TYPE_TRANSFER_TO_STOCK) ? "Передача на склад" : "";
}

//--------------- Статус ---------------
var ACT_STATE_NEW = 0,
    ACT_STATE_CONSIDERATION = 1,
    ACT_STATE_ACCEPTED = 2,
    ACT_STATE_REJECTED = 3,
    ACT_STATE_CONDUCTED = 4,
    ACT_STATE_REJECTED_ALL = 5,
    ACT_STATE_DRAFT = 6,
    ACT_STATE_ERROR_SENT = 7;

var getActAcceptStateClass = function (status) {
    return (status == ACT_STATE_NEW) ? "csNotCheckedBoxLabel" :
        (status == ACT_STATE_CONSIDERATION) ? "csRevokedBoxLabel" :
            (status == ACT_STATE_ACCEPTED) ? "csAcceptBoxLabel" :
                (status == ACT_STATE_REJECTED) ? "csErrorBoxLabel" :
                    (status == ACT_STATE_CONDUCTED) ? "csSentBoxLabel" :
                        (status == ACT_STATE_REJECTED_ALL) ? "csErrorBoxLabel" :
                            (status == ACT_STATE_DRAFT) ? "csDraftBoxLabel" :
                                (status == ACT_STATE_ERROR_SENT) ? "csWaitBoxLabel" : "";

};

var getActAcceptStateText = function (status) {
    return (status == ACT_STATE_NEW) ? "новый" :
        (status == ACT_STATE_CONSIDERATION) ? "в работе" :
            (status == ACT_STATE_ACCEPTED) ? "принят" :
                (status == ACT_STATE_REJECTED) ? "отклонен" :
                    (status == ACT_STATE_CONDUCTED) ? "проведен" :
                        (status == ACT_STATE_REJECTED_ALL) ? "отклонен" :
                            (status == ACT_STATE_DRAFT) ? "черновик" :
                                (status == ACT_STATE_ERROR_SENT) ? "ошибка отправки" : "";
};

//---------------- Синхр. --------------------
var GREEN_ICON = "ball_green.png",
    RED_ICON =  "ball_red.png",
    GREY_ICON = "ball_glass_grey.png",
    BLUE_ICON = "ball_blue.png",
    ABORT_ICON = "abort-icon.png",
    CIRCLE_YELLOW_ICON = "Circle_Yellow.png",
    CIRCLE_RED_ICON = "Circle_Red.png",
    CIRCLE_ORANGE_ICON = "Circle_Orange.png",
    CIRCLE_GREY_ICON = "Circle_Grey.png",
    CIRCLE_GREEN_ICON = "Circle_Green.png",
    CIRCLE_BLUE_ICON = "Circle_Blue.png",
    DRAFT_ICON = "DrawingPin1_Blue.png",
    WARNING_ICON = "Warning_Triangle.png";

var STATUS_NOT_SENT_SERVER = 0,
    STATUS_PROCESSED_SERVER = 1,
    STATUS_ERROR_SERVER = 2,
    STATUS_RECEIVED_SERVER = 3,
    STATUS_SENT_SERVER = 4,
    STATUS_NOT_SENT_TERMINAL = 10,
    STATUS_PROCESSED_TERMINAL = 11,
    STATUS_ERROR_TERMINAL = 12,
    STATUS_SENT_TERMINAL = 13,
    STATUS_SENT_EGAIS = 14,
    STATUS_PROCESSED_EGAIS = 15,
    STATUS_DRAFT = 100;

var getActStatus = function(dataItem){
    var returnStringTemplate = "";
    var tooltip = "";
    if (dataItem.srv_state == STATUS_NOT_SENT_SERVER){
        returnStringTemplate = "<img src='assets/icons/pays/" + RED_ICON + "'></img>";
        tooltip = "Не отправлен на сервер";
    }
    else if (dataItem.srv_state == STATUS_PROCESSED_SERVER){
        returnStringTemplate = "<img src='assets/icons/pays/" + GREEN_ICON + "'></img>";
        tooltip = "Успешно обработан на сервере";
    }
    else if (dataItem.srv_state == STATUS_ERROR_SERVER){
        returnStringTemplate = "<img src='assets/icons/pays/" + ABORT_ICON + "'></img>";
        tooltip = "Ошибка обработки на сервере";
    }
    else if (dataItem.srv_state == STATUS_RECEIVED_SERVER){
        returnStringTemplate = "<img src='assets/icons/pays/" + BLUE_ICON + "'></img>";
        tooltip = "Получен на сервере";
    }
    else if (dataItem.srv_state == STATUS_SENT_SERVER){
        returnStringTemplate = "<img src='assets/icons/pays/" + GREY_ICON + "'></img>";
        tooltip = "Отправлен на сервер";
    }

    else if (dataItem.srv_state == STATUS_NOT_SENT_TERMINAL){
        returnStringTemplate = "<img src='assets/icons/pays/" + CIRCLE_RED_ICON + "'></img>";
        tooltip = "Не отправлен на терминал";
    }
    else if (dataItem.srv_state == STATUS_PROCESSED_TERMINAL){
        returnStringTemplate = "<img src='assets/icons/pays/" + CIRCLE_GREEN_ICON + "'></img>";
        tooltip = "Обработан на терминале";
    }
    else if (dataItem.srv_state == STATUS_ERROR_TERMINAL){
        returnStringTemplate = "<img src='assets/icons/pays/" + WARNING_ICON + "'></img>";
        tooltip = "Ошибка обработки на терминале";
    }
    else if (dataItem.srv_state == STATUS_SENT_TERMINAL){
        returnStringTemplate = "<img src='assets/icons/pays/" + CIRCLE_GREY_ICON + "'></img>";
        tooltip = "Отправлен на терминал";
    }
    else if (dataItem.srv_state == STATUS_SENT_EGAIS){
        returnStringTemplate = "<img src='assets/icons/pays/" + CIRCLE_YELLOW_ICON + "'></img>";
        tooltip = "Отправлен в ЕГАИС";
    }
    else if (dataItem.srv_state == STATUS_PROCESSED_EGAIS){
        returnStringTemplate = "<img src='assets/icons/pays/" + CIRCLE_BLUE_ICON + "'></img>";
        tooltip = "Обработан в ЕГАИС";
    }
    else if (dataItem.srv_state == STATUS_DRAFT){
        returnStringTemplate = "<img src='assets/icons/pays/" + DRAFT_ICON + "'></img>";
        tooltip = "Черновик";
    }

    return "<div class='container-status text-center' title='" + tooltip +"'>" + returnStringTemplate + "</div>";
}

var dataSourceActList;

var reloadActList = function(){
    showProcessAlert("Загрузка актов");

    $("#refreshButton").button('loading');
    clearInterval(timerId);
    timerId = dotted();

    try {
        channel.objects.utm_server.getActs(function (res) {
            hideAlerts();
            clearInterval(timerId);
            $("#refreshButton").button('reset');

            if(res.code == 0) {
                dataSourceActList = res.data.map(function(obj) {
                    return $.extend(true, {}, obj);
                });

                var grid = $("#actListGrid").data("kendoGrid");
                grid.dataSource.data(parseDate(res.data, "act_date"));
                grid.refresh();

                if (grid.dataSource.total() == 0){
                    showInfoAlert("Акты не найдены.");
                }
            } else {
                showErrorMessage(res.message);
            }
        });
    } catch(e) {
        showErrorAlert("<strong>Соединение потеряно или истекло время сессии, попробуйте обновить страницу</strong>");
        clearInterval(timerId);
        $("#refreshButton").button('reset');
    }
}

var showActListView = function() {
    var egaisTtnListView = new kendo.View($('#actListViewTemplate').html());
    layout.showIn("#content", egaisTtnListView);

    $("#refreshButton").kendoButton({
        icon: "refresh",
        click: function(){
            reloadActList();
        }
    });

    $("#actListGrid").kendoGrid({
        dataSource: {
            data : [],
            schema: {
                model: {
                    fields: {
                        id: { type: "number" },
                        srv_id: { type: "number" },
                        srv_state : { type: "number"},
                        srv_state_date: { type: "date" },
                        act_date: { type: "date" },
                        id_type: { type: "number" }
                    }
                }
            }
        },
        filterable: {
            extra: false,
            messages: {
                and: "и",
                or: "или",
                filter: "Фильтр",
                clear: "Очистить",
                info: "Фильтр по значению:",
                selectedItemsFormat: "Выбрано {0} элементов",
                checkAll: "Выбрать Всё"
            },
            operators: {
                string: {
                    contains: "Содержит",
                    eq: "Равно",
                    neq: "Не равно",
                    doesnotcontain: "Не содержит",
                    startswith: "Начинается на",
                    endswith: "Заканчивается на",
                    isempty: "Пустые",
                    isnotempty: "Не пустые"
                },
                number: {
                    eq: "=",
                    neq: "!=",
                    gt: ">",
                    lt: "<",
                    gte: ">=",
                    lte: "<=",
                    isnull: "Null",
                    isnotnull: "!Null"
                },
                date: {
                    gte: "после или равна",
                    gt: "после",
                    lte: "до или равна",
                    lt: "до"
                }
            }
        },
        resizable: true,
        reorderable: true,
        groupable: true,
        sortable: true,
        selectable: "row",
        pageable: {
            pageSize: 20,
            pageSizes: true
        },
        columns: [
            {
                field: "delete_act",
                template: function(dataItem) {
                    return (dataItem.accept_state != undefined && dataItem.accept_state == ACT_STATE_DRAFT) ?
                        "<div class='container-status k-delete-act text-center' title='Удалить акт'>" +
                        "<img width='16' height='16' src='assets/icons/pays/delete.png'></div>" : "";
                },
                title: "Удаление акта", width: 30, filterable: false, sortable: false,
                headerTemplate: ""
            },
            { field: "id", title: "ID локал.", hidden: true, width: 80 },
            { field: "srv_id", title: "ID серв.", hidden: true, width: 80 },
            { field: "act_num", title: "№ акта", attributes:{ "class": "table-cell" }, width: 150 },
            { field: "act_date", title: "Дата", width: 100,
                format: "{0: dd.MM.yyyy}"
            },
            { field: "id_type", title: "Тип", width: 200,
                template: '<span class="#: getActTypeClass(id_type) #">#: getActTypeText(id_type) # </span>',
                filterable: {
                    multi: true,
                    checkAll: true,
                    itemTemplate: function (e) {
                        return "<li class='k-item'>" +
                            "<label>" +
                            "<input type='checkbox' class='k-checkbox' name='" + e.field + "' value='#= data.id_type#'/>" +
                            "<label class='k-checkbox-label check-label'></label>" +
                            "<span>#= getActTypeText(data.id_type) || data.all #</span>" +
                            "</label></li>";
                    }
                }
            },
            { field: "cause", title: "Основание", attributes:{ "class": "table-cell" }, width: 160, filterable: false,
                template: function(dataItem) {
                    var str = dataItem.comment ? dataItem.comment : "";
                    return str.substring(0, str.indexOf("|"));
                }
            },
            { field: "comment", title: "Комментарий", attributes:{ "class": "table-cell" }, width: 160, filterable: false,
                template: function(dataItem) {
                    var str = dataItem.comment ? dataItem.comment : "";
                    return str.substring(str.indexOf("|") + 1);
                }
            },
            {
                field: "accept_state",
                title: "Статус",
                width: 140,
                template: function(dataItem) {
                    return dataItem.accept_state != undefined ?
                        "<span class='" + getActAcceptStateClass(dataItem.accept_state) + "'>" +
                        getActAcceptStateText(dataItem.accept_state) + "</span>" : "";
                },
                filterable: false
            },
            {
                field: "srv_state",
                title: "Синхр.",
                width: 70,
                filterable: false,
                template: getActStatus
            },
            {
                field: "review",
                title: "Просмотр",
                width: 120,
                headerTemplate: "",
                sortable: false,
                filterable: false,
                template: function (dataItem) {
                    var text = "Просмотр";

                    var typeArr = [4, 5, 6, 7, 8, 9];
                    var isActStore = typeArr.some(function(item){
                        return item == dataItem.id_type;
                    });

                    if (dataItem.accept_state == ACT_STATE_DRAFT && isActStore)  {
                        text = "Редактир.";
                    }
                    return "<button class='k-button k-review-act'>" + text + "</button>";
                }
            }
        ],
        dataBound: function() {
            this.table.find("tr[data-uid]").dblclick(reviewAct);
            this.table.find(".k-review-act").click(reviewAct);

            this.table.find(".k-delete-act").click(function(){
                var row = $(this).closest("tr"),
                    grid = $("#actListGrid").data("kendoGrid"),
                    dataItem = grid.dataItem(row);

                confirmMessageDialog.open().center();

                var viewModelConfirmDialog = kendo.observable({
                    message: "Удалить акт?",
                    cancel: function () {
                        confirmMessageDialog.close();
                    },
                    continue: function () {
                        try{
                            var objId = {
                                id: dataItem.id
                            };
                            channel.objects.utm_server.deleteStoreAct(objId, function (result) {
                                if (result.code == 0) {
                                    reloadActList();
                                }
                                else {
                                    showErrorMessage(result.message);
                                }
                            });
                        } catch(e) {
                            showErrorMessage("Произошла ошибка, попробуйте обновить страницу.");
                        }
                        confirmMessageDialog.close();
                    }
                });
                kendo.bind($("#confirmMessageDialog"), viewModelConfirmDialog);
            });

            $(".container-status").kendoTooltip({
                callout: false,
                position: "top"
            });
        },
        dataBinding: function() {
            this.thead.kendoTooltip({
                callout:false,
                position: "top",
                filter: "th",
                content: function (e) {
                    return $(e.target).attr("data-title");
                }
            });
        }
    }).data("kendoGrid");
    bindWinSet('#actListView', "#actListGrid", "cookieActList");

    $("#actListGrid").kendoTooltip({
        filter: "td.table-cell:not(:empty)",
        position: "right",
        animation: {
            open: {
                effects: "fade:in",
                duration: 200
            }
        },
        showAfter: 400,
        content: function(e) {
            var target = e.target;
            var content = target.text();
            return content;
        }
    }).data("kendoTooltip");

    reloadActList();

    function reviewAct() {
        var row = $(this).closest("tr"),
            grid = $("#actListGrid").data("kendoGrid"),
            dataItem = grid.dataItem(row);

        var obj = dataSourceActList.filter(function(item) {
            return item.id == dataItem.id;
        })[0];

        var typeArr = [4, 5, 6, 7, 8, 9];
        var isActStore = typeArr.some(function(item){
            return item == dataItem.id_type;
        });

        if (dataItem.accept_state == ACT_STATE_DRAFT && isActStore) {
            switch(dataItem.id_type) {
                case 4:
                    api.setView("EgaisCreateActBalanceView", obj);
                    showEgaisCreateActBalanceView(obj);
                    break;
                case 5:
                case 7:
                case 8:
                case 9:
                    api.setView("EgaisCreateActWrtOfView", obj);
                    showEgaisCreateActWrtOfView(obj);
                    break;
                case 6:
                    api.setView("EgaisCreateActBalanceSRView", obj);
                    showEgaisCreateActBalanceSRView(obj);
                    break;
            }
            return;
        }

        api.setView("ActInfoView", obj);
        showActInfoView(obj);
    }
}