var validatableFormActBalanceSR,
    objAct,
    objCreateAct;

var editFlag;
var notEqualCount;

var STAMP_DEL_ICON = "delete.png",
    POS_ADD_ICON = "plus-icon.png";

var showEgaisCreateActBalanceSRView = function(editAct) {
    var view = new kendo.View($('#EgaisCreateActBalanceSRViewTemplate').html());
    layout.showIn("#content", view);
    kendo.culture("ru-RU");

    objAct = {};
    objCreateAct = {};

    editFlag = editAct ? true : false;

    viewModel.actFormTitle = !editFlag ? "Акт постановки на баланс в торговом зале" : "Редактирование акта постановки на баланс в торговом зале";
    viewModel.actFormNumber = editFlag && editAct.act_num ? (" № " + editAct.act_num) : "";

    viewModel.actId = editFlag ? editAct.id : null;
    kendo.bind($("span"), viewModel);

    $("#dropdownCause").kendoDropDownList({
        dataSource: {
            data: [ 'Пересортица', 'Излишки', 'Продукция, полученная до 01.01.2016']
        }
    });

    var defaultDate = new Date();
    defaultDate = new Date(defaultDate.getFullYear(), defaultDate.getMonth(), defaultDate.getDate());

    $("#actDate").kendoDatePicker({
        format: "dd.MM.yyyy",
        value: defaultDate
    });
    $("#actDate").attr("readonly", "readonly");

    $("#buttonSend").kendoButton({
        click: function() {
            createActBalanceSR(true);
        }
    });

    $("#buttonSave").kendoButton({
        enable: false,
        click: function() {
            createActBalanceSR();
        }
    });

    var splitter = $("#splitter").kendoSplitter({
        orientation: "vertical",
        panes: [
            { size: "45%", scrollable: false, collapsible: true, collapsedSize: "20%"},
            { size: "55%", scrollable: false, collapsible: true }
        ]
    }).data("kendoSplitter");
    splitter.wrapper.height(700);
    splitter.resize();

//    var jsondata = [];
//    for(var i=0; i< 28; i++)
//        jsondata.push({
//            "id": i+1,
//            capacity: 100*i + 50,
//            product_v_code: 500 * i,
//            name: (i%2==0) ? "Водка русская" : "Водка столичная",
//            producer_name: (i%6==0) ? "ООО Атлант" :
//                (i%6==1) ? "Ника" :
//                    (i%6==2) ? "Союз" :
//                        (i%6==3) ? "Россия" :
//                            (i%6==4) ? "Путинка" :
//                                "Nemiroff" ,
//            producer_id: i+1,
//            producer_client_reg_id: (i%6==0) ? "1" :
//                (i%6==1) ? "2" :
//                    (i%6==2) ? "3" :
//                        (i%6==3) ? "4" :
//                            (i%6==4) ? "5" :
//                                "6" ,
//            producer_inn: (i%6==0) ? "1" :
//                (i%6==1) ? "2" :
//                    (i%6==2) ? "3" :
//                        (i%6==3) ? "4" :
//                            (i%6==4) ? "5" :
//                                "6" ,
//            producer_kpp: (i%6==0) ? "1" :
//                (i%6==1) ? "2" :
//                    (i%6==2) ? "3" :
//                        (i%6==3) ? "4" :
//                            (i%6==4) ? "5" :
//                                "6" ,
//            importer_name: (i%2==0) ? "ТрансАвто" : "ООО Грузовые перевозки",
//            importer_id: i+1,
//            importer_client_reg_id: (i%6==0) ? "1" :
//                (i%6==1) ? "2" :
//                    (i%6==2) ? "3" :
//                        (i%6==3) ? "4" :
//                            (i%6==4) ? "5" :
//                                "6" ,
//            importer_inn: (i%6==0) ? "1" :
//                (i%6==1) ? "2" :
//                    (i%6==2) ? "3" :
//                        (i%6==3) ? "4" :
//                            (i%6==4) ? "5" :
//                                "6" ,
//            importer_kpp: (i%6==0) ? "1" :
//                (i%6==1) ? "2" :
//                    (i%6==2) ? "3" :
//                        (i%6==3) ? "4" :
//                            (i%6==4) ? "5" :
//                                "6" ,
//            alc_code: "743829563486583",
//            ean: "12032021",
//            user_rec: i%2==0 ? 1 : 0
//        });

    DATA_SOURCE_POS_LIST = new kendo.data.DataSource({
        data: [],
        schema: {
            model: {
                id: "id",
                fields: {
                    identity: { editable: false },
                    name: { editable: false },
                    alc_code: { editable: false },
                    quantity: {
                        type: "number",
                        validation: {
                            min: 0
                        }
                    }
                }
            }
        }
    });

    $("#positionsListGrid").kendoGrid({
        dataSource: DATA_SOURCE_POS_LIST,
        filterable: false,
        resizable: true,
        sortable: false,
        selectable: "multiple, row",
        height: "100%",
        toolbar: [
            { template: kendo.template($("#toolbarPosListGrid").html()) }
        ],
        columns: [
            { field: "identity", title: "№", width: 40, filterable: false,
                template: function(dataItem){
                    var ds = $("#positionsListGrid").data("kendoGrid").dataSource,
                        index = ds.indexOf( dataItem );
                    return index + 1;
                }
            },

            { field: "name", title: "Наименование", attributes:{ "class": "table-cell" }, width: 230 },
            { field: "alc_code", title: "Код ЕГАИС", attributes:{ "class": "table-cell" }, width: 180 },
            { field: "quantity", title: "Кол-во", width: 90, filterable: false,
                template: function(dataItem) {
                    return dataItem.capacity == 0 ? (kendo.toString(dataItem.quantity / 10000, "n3") + " дал") :
                        dataItem.quantity;
                }
            }
        ],
        editable: {
            mode: "incell",
            confirmation: false
        },
        edit: function(e) {
//            if (e.model.isNew()) {
            var grid = $("#positionsListGrid").data("kendoGrid"),
                row = grid.select(),
                dataItem = grid.dataItem(row),
                value;

            var numeric = e.container.find("input[name=quantity]").data("kendoNumericTextBox");
            if(numeric){
                var quantity;
                if(dataItem.capacity == 0) {
                    numeric.options.format = "n3";
                    numeric.options.decimals = 3;

                    quantity = dataItem.quantity / 10000;
                    numeric.value(quantity);
                } else {
                    numeric.options.format = "n0";
                    numeric.options.decimals = 0;
                }

                numeric.bind("change", function(){
                    if(dataItem.capacity == 0) {
                        dataItem.quantity  = this.value() * 10000;
                    }
                    grid.saveRow();
                });
            }
//            }
        },
        dataBound: function() {
            var lenght = this.dataSource.data().length;
            $("#buttonSend").data("kendoButton").enable(lenght > 0 ? true : false);
        }
    }).data("kendoGrid");

    $("#positionsListGrid").kendoTooltip({
        filter: "td.table-cell:not(:empty)",
        position: "right",
        animation: {
            open: {
                effects: "fade:in",
                duration: 200
            }
        },
        showAfter: 400,
        content: function(e) {
            var target = e.target;
            var content = target.text();
            return content;
        }
    }).data("kendoTooltip");

    $('#btnDelPos').kendoButton({
        imageUrl: "assets/icons/pays/" + STAMP_DEL_ICON,
        click: function() {
            var grid = $("#positionsListGrid").data("kendoGrid");
            var selectedRows = grid.select();

            for (var i = 0; i < selectedRows.length; i++) {
                grid.removeRow(selectedRows[i]);
            }

            var grid = $("#productsListGrid").data("kendoGrid");
            grid.select(grid.select());
        }
    });

    //-------------------------------------------------
    $("#productsListGrid").kendoGrid({
        dataSource  : {
            data: [],
            schema: {
                model: {
                    id: "id",
                    fields: {
                        identity: { editable: false },
                        name: { editable: false },
                        alc_code: { editable: false },
                        quantity: {
                            type: "number",
                            validation: {
                                min: 0
                            }
                        }
                    }
                }
            }
        },
        filterable: {
            messages: {
                and: "и",
                or: "или",
                filter: "Фильтр",
                clear: "Очистить",
                info: "Фильтр по значению:"
            },
            operators: {
                string: {
                    eq: "Равно",
                    neq: "Не равно",
                    contains: "Содержит",
                    doesnotcontain: "Не содержит",
                    startswith: "Начинается на",
                    endswith: "Заканчивается на",
                    isempty: "Пустые",
                    isnotempty: "Не пустые"
                },
                number: {
                    eq: "=",
                    neq: "!=",
                    gt: ">",
                    lt: "<",
                    gte: ">=",
                    lte: "<=",
                    isnull: "Null",
                    isnotnull: "!Null"
                }
            },
            extra: false
        },
        resizable: true,
        sortable: true,
        selectable: "row",
        height: "100%",
        pageable: {
            pageSize: 20,
            pageSizes: true
        },
        toolbar: [
            { template: kendo.template($("#toolbarProductsListGrid").html()) }
        ],
        columns: [
            { field: "product_v_code", title: "Группа", width: 70, filterable: false },
            { field: "name", title: "Наименование", attributes:{ "class": "table-cell" }, width: 230, filterable: true },
            { field: "capacity", title: "Объем", width: 70, filterable: false,
                template: function(dataItem) {
                    return dataItem.capacity ? kendo.toString(dataItem.capacity / 1000, "n2") + " л" : "не фас.";
                }
            },
            { field: "alc_code", title: "Код ЕГАИС", width: 180, filterable: true },
            { field: "ean", title: "Штрихкод", width: 110, filterable: true },
            { field: "producer_name", title: "Производитель", attributes:{ "class": "table-cell" }, width: 180, filterable: true },
            { field: "producer_inn", title: "ИНН", width: 120, filterable: true },
            { field: "producer_kpp", title: "КПП", width: 120, filterable: true },
            { field: "importer_name", title: "Импортер", attributes:{ "class": "table-cell" }, width: 180, filterable: true },
            { field: "importer_inn", title: "ИНН", width: 120, filterable: true },
            { field: "importer_kpp", title: "КПП", width: 120, filterable: true }
        ],
        change: function(e) {
            var button = $("#btnAddPos").data("kendoButton");

            var row = this.select();
            var dataItem = this.dataItem(row);

            var flag = DATA_SOURCE_POS_LIST.data().some(function(item) {
                return item.id_product == dataItem.id;
            });
            var index = DATA_SOURCE_POS_LIST.indexOf(dataItem);
            if(index == -1 && !flag){
                button.enable(true);
            } else {
                button.enable(false);
            }
        }
    });

    $("#inpSearch").keyup(function () {
        filterAllGrid(this, "productsListGrid");
    });
    $('#btnClean').kendoButton({
        icon: "arrowhead-w",
        click: function(){
            var grid = $("#productsListGrid").data("kendoGrid");
            grid.dataSource.filter({});

            $("#inpSearch").val("");
        }
    });
    $('#btnAddPos').kendoButton({
        imageUrl: "assets/icons/pays/" + POS_ADD_ICON,
        click: addRow
    });

    function addRow(event) {
        var grid = $("#productsListGrid").data("kendoGrid");
        var row = grid.select();
        var dataItem = grid.dataItem(row);

        var flag = DATA_SOURCE_POS_LIST.data().some(function(item) {
            return item.id_product == dataItem.id;
        });
        var index = DATA_SOURCE_POS_LIST.indexOf(dataItem);
        if(index == -1 && !flag){
            dataItem.quantity = 0;
            dataItem.old_quantity = dataItem.quantity;
            DATA_SOURCE_POS_LIST.insert(0, dataItem);
        }
    }

    var productsListGrid = $("#productsListGrid").data("kendoGrid");
    productsListGrid.bind("dataBound", function(){
        this.table.find("tr[data-uid]").dblclick(addRow);

        var button = $("#btnAddPos").data("kendoButton");
        button.enable(false);
    });
    productsListGrid.dataSource.fetch();

    $("#productsListGrid").kendoTooltip({
        filter: "td.table-cell:not(:empty)",
        position: "right",
        animation: {
            open: {
                effects: "fade:in",
                duration: 200
            }
        },
        showAfter: 400,
        content: function(e) {
            var target = e.target;
            var content = target.text();
            return content;
        }
    }).data("kendoTooltip");

    $(".k-button-toolbar").kendoTooltip({
        callout: false,
        position: "top"
    });

    reloadProductsList();
    refreshControlsActBalanceSR(editAct);
    if(editFlag) {
        refreshPositionsActBalanceSR(editAct.id);
    }

    function reloadProductsList(){
        kendo.ui.progress($("#productsListGrid"), true);

        try {
            channel.objects.utm_server.getProducts(function (response) {
                if(response.code == 0) {
                    var grid = $("#productsListGrid").data("kendoGrid");
                    var data = response.data;

                    for (var i = 0; i < data.length; i++) {
                        data[i].producer_short_name = data[i].producer_name;
                        data[i].producer_full_name = data[i].producer_name;
                        data[i].importer_short_name = data[i].importer_name;
                        data[i].importer_full_name = data[i].importer_name;
                    }

                    grid.dataSource.data(data);
                    grid.refresh();
                }
                else {
                    showErrorAlert(response.message);
                }
            });
        } catch(e) {
            showErrorAlert("<strong>Не удалось загрузить справочник товаров, попробуйте обновить страницу.</strong>");
        } finally {
            kendo.ui.progress($("#productsListGrid"), false);
        }
    }

    validatableFormActBalanceSR = $("#formAct").kendoValidator({
        validateOnBlur: false,
        messages: {
            required: function(input){
                return input.data("message");
            }
        }
    }).data("kendoValidator");
}

function refreshControlsActBalanceSR(editAct){
    var dropdownlist = $("#dropdownCause").data("kendoDropDownList");
    var comment = "",
        cause = "";
    var comm;

    if(!editFlag) {
        try {
            var obj = {
                type: 6
            };
            channel.objects.utm_server.createStoreAct(obj, function (res) {
                if(res.code == 0) {
                    objCreateAct = res.data;
//                    console.log(JSON.stringify(objCreateAct));

                    comm = objCreateAct.comment;
                    if(comm) {
                        comment = comm.substring(comm.indexOf("|") + 1);
                        cause = comm.substring(0, comm.indexOf("|"));
                    }

                    $("#actNumber").val(objCreateAct.num);
                    $("#actComment").val(comment);

                    dropdownlist.value(cause);
                    dropdownlist.trigger("change");

                    $("#buttonSave").data("kendoButton").enable(true);
                }
                else {
                    showErrorMessage(res.message);
                }
            });
        } catch (e) {
            showErrorMessage("При создании акта произошла ошибка, попробуйте обновить страницу.");
        }
    } else {
        comm = editAct.comment;
        if(comm) {
            comment = comm.substring(comm.indexOf("|") + 1);
            cause = comm.substring(0, comm.indexOf("|"));
        }

        $("#actNumber").val(editAct.act_num ? editAct.act_num : "");
        $("#actComment").val(comment);

        dropdownlist.value(cause);
        dropdownlist.trigger("change");

        $("#buttonSave").data("kendoButton").enable(true);
    }
}

function refreshPositionsActBalanceSR(actId){
    try {
        var obj = {
            id: actId
        };
        channel.objects.utm_server.getActPositions(obj, function (res) {
            if(res.code == 0) {
                var positions = res.data;

                for (var i = 0; i < positions.length; i++) {
                    //заполняем позиции
                    var pos = positions[i];
                    pos.quantity = pos.qty;
                    pos.old_quantity = pos.quantity;

                    DATA_SOURCE_POS_LIST.add(pos);
                    $("#positionsListGrid").data("kendoGrid").select("tr:last-child");
                }
            } else {
                showErrorMessage(res.message);
            }
        });
    } catch(e) {
        showErrorMessage("Не удалось загрузить список позиций акта, попробуйте обновить страницу.");
    }
}

function createActBalanceSR(sendFlag){
    if (validatableFormActBalanceSR.validateInput($("input[name=number]")) &
        validatableFormActBalanceSR.validateInput($("input[name=cause]"))) {
        hideAlerts();

        var actDate = $("#actDate").data("kendoDatePicker");
        var posList = parseDataPosGridActBalSR($("#positionsListGrid").data("kendoGrid").dataSource.data());
        var cause = $("#dropdownCause").data("kendoDropDownList").value();

        objAct = {
            actType: 6,
            num: $("#actNumber").val(),
            actDate: new Date(actDate.value()).toISOString(),
            comment: cause + "|" + $("#actComment").val(),
            positions: posList
        };

        if(notEqualCount) {
            showWarningMessage("В некоторых позициях количество товара не соотвествует количеству федеральных марок.");
            return;
        }

        if(sendFlag) {
            confirmMessageDialog.open().center();

            var viewModelConfirmDialog = kendo.observable({
                message: "После отправки в УТМ акт будет недоступен для редактирования.",
                cancel: function () {
                    confirmMessageDialog.close();
                },
                continue: function () {
                    confirmMessageDialog.close();
                    creatingActBalanceSR(true);
                }
            });
            kendo.bind($("#confirmMessageDialog"), viewModelConfirmDialog);

        } else {
            creatingActBalanceSR();
        }

    } else {
        showWarningMessage("Не заполнены обязательные поля.");
    }
}

function creatingActBalanceSR(sendFlag){
//    console.log(JSON.stringify(objAct));
    if(!editFlag) {
        $.extend(objCreateAct, objAct);
        objAct = objCreateAct;
    } else {
        objAct.id = viewModel.actId;
    }
    saveActBalanceSR(sendFlag);
};

function saveActBalanceSR(sendFlag){
    showProcessAlert((sendFlag ? "Отправка" : "Сохранение") + " акта");
    if(sendFlag)
        $("#buttonSend").button('loading');
    else
        $("#buttonSave").button('loading');
    clearInterval(timerId);
    timerId = dotted();

    try {
        channel.objects.utm_server.saveStoreAct(objAct, function(res){
            if(sendFlag){
                var id = { id: objAct.id };
                try {
                    channel.objects.utm_server.sendStoreAct(id, function (result) {
                        hideAlerts();

                        if (result.code == 0) {
                            if (result.data.deferred && result.data.deferred == 1)
                                showWarningMessage("Утм в данный момент недоступен. Акт поставлен в очередь. Отправится, когда заработает утм.");
                            else {
                                api.setView('ActListView');
                                showActListView();
                                showSuccessMessage("Акт успешно отправлен.");
                            }
                        }
                        else {
                            showErrorMessage(result.message);
                        }
                    });
                } catch(e) {
                    showErrorMessage("При отправке акта произошла ошибка, попробуйте обновить страницу.");
                    hideAlerts();
                } finally {
                    clearInterval(timerId);
                    $("#buttonSend").button('reset');
                }
            } else {
                hideAlerts();

                if(res.code == 0) {
                    api.setView('ActListView');
                    showActListView();
                    showSuccessMessage("Акт успешно сохранен.");
                }
                else {
                    showErrorMessage(res.message);
                }
            }
        });
    } catch (e) {
        if(sendFlag) {
            showErrorMessage("При отправке акта произошла ошибка, попробуйте обновить страницу.");
            hideAlerts();

            clearInterval(timerId);
            $("#buttonSend").button('reset');
        } else {
            showErrorMessage("При сохранении акта произошла ошибка, попробуйте обновить страницу.");
            hideAlerts();
        }
    } finally {
        if(!sendFlag) {
            clearInterval(timerId);
            $("#buttonSave").button('reset');
        }
    }
}

function parseDataPosGridActBalSR(data){
    var result = [];

//    перебираем список позиций
    for (var i = 0; i < data.length; i++) {
        result.push({
            identity: i+1,
            quantity: data[i].quantity,
            currFormBRegId: "",
            product: {
                producer: {
                    inn: data[i].producer_inn,
                    kpp: data[i].producer_kpp,
                    clientRegId: data[i].producer_client_reg_id,
                    fullName: data[i].producer_full_name,
                    shortName: data[i].producer_short_name
                },
                importer: {
                    inn: data[i].importer_inn,
                    kpp: data[i].importer_kpp,
                    clientRegId: data[i].importer_client_reg_id,
                    fullName: data[i].importer_full_name,
                    shortName: data[i].importer_short_name
                },
                name: data[i].name,
                capacity: data[i].capacity,
                egaisCode: data[i].alc_code,
                productCode: data[i].product_v_code
            }
        });
    }
    return result;
}