var viewModelAct,
    validatableFormAct,
    objAct,
    objCreateAct;

var editFlag;

var STAMP_ADD_ICON = "stamp.png",
    STAMP_DEL_ICON = "delete.png",
    POS_ADD_ICON = "plus-icon.png";

var showEgaisCreateActView = function(editAct) {
    var view = new kendo.View($('#EgaisCreateActViewTemplate').html());
    layout.showIn("#content", view);
    kendo.culture("ru-RU");

    objAct = {};
    objCreateAct = {};
    DATA_PERSONS = [];
    STAMPS_LIST_FOR_POS = {};
    INFO_FORM_A = {};

    editFlag = editAct ? true : false;

    viewModel.actFormTitle = "Акт постановки на баланс";

    viewModel.actId = editFlag ? editAct.doc_id : null;
    kendo.bind($("span"), viewModel);

    $("#dropdownActType").kendoDropDownList({
        valuePrimitive: true,
        dataTextField: "name",
        dataValueField: "value"
    });

    var defaultDate = new Date();
    defaultDate = new Date(defaultDate.getFullYear(), defaultDate.getMonth(), defaultDate.getDate());

    $("#actDate").kendoDatePicker({
        format: "dd.MM.yyyy",
        value: defaultDate
    });
    $("#actDate").attr("readonly", "readonly");

    $("#buttonSend").kendoButton({
        click: function() {
            createAct(true);
        }
    });

    $("#buttonSave").kendoButton({
        enable: false,
        click: function() {
            createAct();
        }
    });

    var splitter = $("#splitter").kendoSplitter({
        orientation: "vertical",
        panes: [
            { size: "45%", scrollable: false, collapsible: true, collapsedSize: "20%"},
            { size: "55%", scrollable: false, collapsible: true }
        ]
    }).data("kendoSplitter");
    splitter.wrapper.height(700);
    splitter.resize();

    var horizontal = $("#horizontal").kendoSplitter({
        orientation: "horizontal",
        panes: [
            { scrollable: false },
            { scrollable: false }
        ]
    }).data("kendoSplitter");
    horizontal.wrapper.height('100%');
    horizontal.resize();

    resizeSplitter();

    viewModelAct = kendo.observable({
        selectedActType: 4,
        actType: [
            { value: 4, name: "Акт постановки на баланс" },
            { value: 5, name: "Акт списания" }
        ],
        isEnableActType: true
    });
    kendo.bind($("#formAct"), viewModelAct);

    var jsondata = [];
    for(var i=0; i< 28; i++)
        jsondata.push({
            "id": i+1,
            capacity: 100*i + 50,
            product_v_code: 200 * i,
            name: (i%2==0) ? "Водка русская" : "Водка столичная",
            producer_name: (i%6==0) ? "ООО Атлант" :
                (i%6==1) ? "Ника" :
                    (i%6==2) ? "Союз" :
                        (i%6==3) ? "Россия" :
                            (i%6==4) ? "Путинка" :
                                "Nemiroff" ,
            producer_id: i+1,
            producer_client_reg_id: (i%6==0) ? "1" :
                (i%6==1) ? "2" :
                    (i%6==2) ? "3" :
                        (i%6==3) ? "4" :
                            (i%6==4) ? "5" :
                                "6" ,
            producer_inn: (i%6==0) ? "1" :
                (i%6==1) ? "2" :
                    (i%6==2) ? "3" :
                        (i%6==3) ? "4" :
                            (i%6==4) ? "5" :
                                "6" ,
            producer_kpp: (i%6==0) ? "1" :
                (i%6==1) ? "2" :
                    (i%6==2) ? "3" :
                        (i%6==3) ? "4" :
                            (i%6==4) ? "5" :
                                "6" ,
            importer_name: (i%2==0) ? "ТрансАвто" : "ООО Грузовые перевозки",
            importer_id: i+1,
            importer_client_reg_id: (i%6==0) ? "1" :
                (i%6==1) ? "2" :
                    (i%6==2) ? "3" :
                        (i%6==3) ? "4" :
                            (i%6==4) ? "5" :
                                "6" ,
            importer_inn: (i%6==0) ? "1" :
                (i%6==1) ? "2" :
                    (i%6==2) ? "3" :
                        (i%6==3) ? "4" :
                            (i%6==4) ? "5" :
                                "6" ,
            importer_kpp: (i%6==0) ? "1" :
                (i%6==1) ? "2" :
                    (i%6==2) ? "3" :
                        (i%6==3) ? "4" :
                            (i%6==4) ? "5" :
                                "6" ,
            alc_code: "743829563486583",
            ean: "12032021",
            user_rec: i%2==0 ? 1 : 0
        });

    DATA_SOURCE_POS_LIST = new kendo.data.DataSource({
        data: [],
        schema: {
            model: {
                fields: {

                }
            }
        }
    });

    $("#positionsListGrid").kendoGrid({
        dataSource: DATA_SOURCE_POS_LIST,
        filterable: false,
        resizable: true,
        sortable: false,
        selectable: "multiple, row",
        height: "100%",
        toolbar: [
            { template: kendo.template($("#toolbarPosListGrid").html()) }
        ],
        columns: [
            { field: "identity", title: "№", width: 40, filterable: false,
                template: function(dataItem){
                    var ds = $("#positionsListGrid").data("kendoGrid").dataSource,
                        index = ds.indexOf( dataItem );
                    return index + 1;
                }
            },

            { field: "name", title: "Наименование", attributes:{ "class": "table-cell" }, width: 230 },
            { field: "alc_code", title: "Код ЕГАИС", attributes:{ "class": "table-cell" }, width: 180 },
            { field: "quantity", title: "Кол-во", width: 90, filterable: false }
        ],
        editable: {
            mode: "incell",
            confirmation: false
        },
        edit: function(e) {
//            if (e.model.isNew()) {
            var grid = $("#positionsListGrid").data("kendoGrid"),
                row = grid.select(),
                dataItem = grid.dataItem(row),
                value;

            var numeric = e.container.find("input[name=quantity]").data("kendoNumericTextBox");
            if(numeric){
                numeric.options.format = "n0";
                numeric.options.decimals = 0;

                numeric.bind("change", function(){
                    grid.saveRow();
                });
                $("input[name=quantity]").closest("td").dblclick( function(){
                    event.stopPropagation ? event.stopPropagation() : (event.cancelBubble=true);
                });
            }
//            }
        },
        dataBound: function() {
            var lenght = this.dataSource.data().length;
            $("#buttonSend").data("kendoButton").enable(lenght > 0 ? true : false);

            this.table.find("tr[data-uid]").dblclick( function(){
                var row = $(this).closest("tr"),
                    grid = $("#positionsListGrid").data("kendoGrid"),
                    dataItem = grid.dataItem(row);

                showInfoFormADialogView(dataItem, true);
            });
        },
        change: function(e) {
            var row = this.select();
            var dataItem = this.dataItem(row);
            DATA_SOURCE_STAMPS_LIST.data(STAMPS_LIST_FOR_POS[dataItem.id]);
        }
    }).data("kendoGrid");

    $("#positionsListGrid").kendoTooltip({
        filter: "td.table-cell:not(:empty)",
        position: "right",
        animation: {
            open: {
                effects: "fade:in",
                duration: 200
            }
        },
        showAfter: 400,
        content: function(e) {
            var target = e.target;
            var content = target.text();
            return content;
        }
    }).data("kendoTooltip");

    $('#btnDelPos').kendoButton({
        imageUrl: "assets/icons/pays/" + STAMP_DEL_ICON,
        click: function() {
            var grid = $("#positionsListGrid").data("kendoGrid");
            var selectedRows = grid.select();
            for (var i = 0; i < selectedRows.length; i++) {
                var dataItem = grid.dataItem(selectedRows[i]);
                var index = dataItem.id;
                delete STAMPS_LIST_FOR_POS[index];
                delete INFO_FORM_A[index];
            }

            for (var i = 0; i < selectedRows.length; i++) {
                grid.removeRow(selectedRows[i]);
            }

            if(selectedRows.length) DATA_SOURCE_STAMPS_LIST.data([]);
            var grid = $("#productsListGrid").data("kendoGrid");
            grid.select(grid.select());
        }
    });

    //-------------------------------------------------
    DATA_SOURCE_STAMPS_LIST = new kendo.data.DataSource({
        data: [],
        schema: {
            model: {
                fields: {

                }
            }
        }
    });

    var stampsListGrid = $("#stampsListGrid").kendoGrid({
        dataSource: DATA_SOURCE_STAMPS_LIST,
        filterable: false,
        resizable: true,
        sortable: false,
        selectable: "multiple, row",
        height: "100%",
        toolbar: [
            { template: kendo.template($("#toolbarStampsListGrid").html()) }
        ],
        columns: [
            { field: "identity", title: "№", width: 40, filterable: false,
                template: function(dataItem){
                    var ds = $("#stampsListGrid").data("kendoGrid").dataSource,
                        index = ds.indexOf( dataItem );
                    return index + 1;
                }
            },

            { field: "name", title: "Марка", attributes:{ "class": "table-cell" }, width: 230 }
        ]
    }).data("kendoGrid");

    $('#btnAddStamp').kendoButton({
        imageUrl: "assets/icons/pays/" + STAMP_ADD_ICON,
        click: function() {
            showEnterStompsDialogView();
        }
    });
    $('#btnDelStamp').kendoButton({
        imageUrl: "assets/icons/pays/" + STAMP_DEL_ICON,
        click: function() {
            var grid = $("#stampsListGrid").data("kendoGrid");
            var selectedRows = grid.select();
            for (var i = 0; i < selectedRows.length; i++) {
                grid.removeRow(selectedRows[i]);
            }
        }
    });

    stampsListGrid.bind("dataBound", function(){
        var button = $("#btnAddStamp").data("kendoButton");
        var grid = $("#positionsListGrid").data("kendoGrid");
        var row = grid.select();

        var dataItem = grid.dataItem(row);
        if(dataItem) {
            button.enable(true);
            var select = dataItem.id;

            var data = $("#stampsListGrid").data("kendoGrid").dataSource.data();
            STAMPS_LIST_FOR_POS[select] = data;
        } else {
            button.enable(false);
        }
    });
    stampsListGrid.dataSource.fetch();

    //---------------------------------------------------
    $("#productsListGrid").kendoGrid({
        dataSource  : {
            data: [],
            schema: {
                model: {
                    id: "id",
                    fields: {
                        identity: { editable: false },
                        name: { editable: false },
                        alc_code: { editable: false },
                        quantity: {
                            type: "number",
                            validation: {
                                min: 0
                            }
                        }
                    }
                }
            }
        },
        filterable: {
            messages: {
                and: "и",
                or: "или",
                filter: "Фильтр",
                clear: "Очистить",
                info: "Фильтр по значению:"
            },
            operators: {
                string: {
                    eq: "Равно",
                    neq: "Не равно",
                    contains: "Содержит",
                    doesnotcontain: "Не содержит",
                    startswith: "Начинается на",
                    endswith: "Заканчивается на",
                    isempty: "Пустые",
                    isnotempty: "Не пустые"
                },
                number: {
                    eq: "=",
                    neq: "!=",
                    gt: ">",
                    lt: "<",
                    gte: ">=",
                    lte: "<=",
                    isnull: "Null",
                    isnotnull: "!Null"
                }
            },
            extra: false
        },
        resizable: true,
        sortable: true,
        selectable: "row",
        height: "100%",
        pageable: {
            pageSize: 20,
            pageSizes: true
        },
        toolbar: [
            { template: kendo.template($("#toolbarProductsListGrid").html()) }
        ],
        columns: [
            { field: "product_v_code", title: "Группа", width: 70, filterable: false },
            { field: "name", title: "Наименование", attributes:{ "class": "table-cell" }, width: 230, filterable: true },
            { field: "capacity", title: "Объем", width: 70, filterable: false,
                template: function(dataItem) {
                    return dataItem.capacity ? kendo.toString(dataItem.capacity / 1000, "n2") + " л" : "...";
                }
            },
            { field: "alc_code", title: "Код ЕГАИС", width: 180, filterable: true },
            { field: "ean", title: "Штрихкод", width: 110, filterable: true },
            { field: "producer_name", title: "Производитель", attributes:{ "class": "table-cell" }, width: 180, filterable: true },
            { field: "producer_inn", title: "ИНН", width: 120, filterable: true },
            { field: "producer_kpp", title: "КПП", width: 120, filterable: true },
            { field: "importer_name", title: "Импортер", attributes:{ "class": "table-cell" }, width: 180, filterable: true },
            { field: "importer_inn", title: "ИНН", width: 120, filterable: true },
            { field: "importer_kpp", title: "КПП", width: 120, filterable: true }
        ],
        change: function(e) {
            var button = $("#btnAddPos").data("kendoButton");

            var row = this.select();
            var dataItem = this.dataItem(row);

            var index = DATA_SOURCE_POS_LIST.indexOf(dataItem);
            if(index == -1){
                button.enable(true);
            } else {
                button.enable(false);
            }
        }
    });

    $("#inpSearch").keyup(function () {
        filterAllGrid(this, "productsListGrid");
    });
    $('#btnClean').kendoButton({
        icon: "arrowhead-w",
        click: function(){
            var grid = $("#productsListGrid").data("kendoGrid");
            grid.dataSource.filter({});

            $("#inpSearch").val("");
        }
    });
    $('#btnAddPos').kendoButton({
        imageUrl: "assets/icons/pays/" + POS_ADD_ICON,
        click: addRow
    });

    function addRow(event) {
        var grid = $("#productsListGrid").data("kendoGrid");
        var row = grid.select();
        var dataItem = grid.dataItem(row);

        var index = DATA_SOURCE_POS_LIST.indexOf(dataItem);
        if(index == -1){
            dataItem.quantity = 0;

            showInfoFormADialogView(dataItem);
        }
    }

    var productsListGrid = $("#productsListGrid").data("kendoGrid");
    productsListGrid.bind("dataBound", function(){
        this.table.find("tr[data-uid]").dblclick(addRow);

        var button = $("#btnAddPos").data("kendoButton");
        button.enable(false);
    });
    productsListGrid.dataSource.fetch();

    $("#productsListGrid").kendoTooltip({
        filter: "td.table-cell:not(:empty)",
        position: "right",
        animation: {
            open: {
                effects: "fade:in",
                duration: 200
            }
        },
        showAfter: 400,
        content: function(e) {
            var target = e.target;
            var content = target.text();
            return content;
        }
    }).data("kendoTooltip");

    $(".k-button-toolbar").kendoTooltip({
        callout: false,
        position: "top"
    });

    reloadProductsList();
    refreshControls(editAct);

    function reloadProductsList(){
        kendo.ui.progress($("#productsListGrid"), true);

        try {
            channel.objects.utm_server.getProducts(function (response) {
                if(response.code == 0) {
                    var grid = $("#productsListGrid").data("kendoGrid");
                    grid.dataSource.data(response.data);
//                    grid.dataSource.data(jsondata);
                    grid.refresh();
                }
                else {
                    showErrorAlert(response.message);
                }
            });
        } catch(e) {
            showErrorAlert("<strong>Не удалось загрузить справочник товаров, попробуйте обновить страницу.</strong>");
        } finally {
            kendo.ui.progress($("#productsListGrid"), false);
        }
    }

    validatableFormAct = $("#formAct").kendoValidator({
        validateOnBlur: false,
        messages: {
            required: function(input){
                return input.data("message");
            }
        }
    }).data("kendoValidator");
}

function refreshControls(editAct){
    if(!editFlag) {
        try {
            channel.objects.utm_server.createActChargeOn(function (res) {
                if(res.code == 0) {
                    objCreateAct = res.data;
//                    console.log(JSON.stringify(objCreateAct));
                    viewModelAct.set("selectedActType", 4);
                    $("#actNumber").val(objCreateAct.num);
                    $("#actComment").val(objCreateAct.comment);

                    $("#buttonSave").data("kendoButton").enable(true);
                }
                else {
                    showErrorMessage(res.message);
                }
            });
        } catch (e) {
            showErrorMessage("При создании акта произошла ошибка, попробуйте обновить страницу.");
        }
    } else {
        viewModelAct.set("selectedActType", editAct.doc_type);
        $("#actNumber").val(editAct.doc_num ? editAct.doc_num : "");
        $("#actComment").val(editAct.comment ? editAct.comment : "");

        $("#buttonSave").data("kendoButton").enable(true);
    }
}

//function refreshDocPositions(editAct, products){
//    try {
//        channel.objects.utm_server.getDocPositions(editAct.doc_id, function (result) {
//            var posList = result.data;
//
//            var grid = $("#productsListGrid").data("kendoGrid");
//            var posGrid = $("#positionsListGrid").data("kendoGrid");
//
//            for (var i = 0; i < posList.length; i++) {
//                for (var j = 0; j < products.length; j++) {
//                    if (posList[i].curr_form_b_reg_id == products[j].form_b_reg_id &&
//                        posList[i].id == products[j].id) {
//
//                        var dataItem = grid.dataSource.get(products[j].id);
//                        var index = posGrid.dataSource.indexOf(dataItem);
//                        if (index == -1) {
//                            dataItem.quantity = Math.min(dataItem.qty, posList[i].qty);
//                            posGrid.dataSource.add(dataItem);
//                        }
//
//                        break;
//                    }
//                }
//            }
//        });
//    } catch(e) {
//        showErrorMessage("Не удалось загрузить список позиций накладной, попробуйте обновить страницу.");
//    }
//}

function createAct(sendFlag){
    if (validatableFormAct.validateInput( $("input[name=number]") )) {
        hideAlerts();

        var actDate = $("#actDate").data("kendoDatePicker");
        var posList = parseDataPositionsListGrid($("#positionsListGrid").data("kendoGrid").dataSource.data());

        objAct = {
            actType: viewModelAct.get("selectedActType"),
            num: $("#actNumber").val(),
            actDate: new Date(actDate.value()).toISOString(),
            comment: $("#actComment").val(),
            positions: posList
        };

        if(sendFlag) {
            confirmMessageDialog.open().center();

            var viewModelConfirmDialog = kendo.observable({
                message: "После отправки в УТМ акт будет недоступен для редактирования.",
                cancel: function () {
                    confirmMessageDialog.close();
                },
                continue: function () {
                    confirmMessageDialog.close();
                    creatingAct(true);
                }
            });
            kendo.bind($("#confirmMessageDialog"), viewModelConfirmDialog);

        } else {
            creatingAct();
        }

    } else {
        showWarningMessage("Не заполнены обязательные поля.");
    }
}

function creatingAct(sendFlag){
//    console.log(JSON.stringify(objAct));
    if(!editFlag) {
        $.extend(objCreateAct, objAct);
        objAct = objCreateAct;
    } else {
        objAct.id = viewModel.actId;
    }
    saveAct(sendFlag);
};

function saveAct(sendFlag){
    showProcessAlert((sendFlag ? "Отправка" : "Сохранение") + " акта");
    if(sendFlag)
        $("#buttonSend").button('loading');
    else
        $("#buttonSave").button('loading');
    clearInterval(timerId);
    timerId = dotted();

    try {
        channel.objects.utm_server.saveActChargeOn(objAct, function(res){
            if(sendFlag){
                var id = { id: objAct.id };
                try {
                    channel.objects.utm_server.sendActChargeOn(id, function (result) {
                        hideAlerts();

                        if (result.code == 0) {
                            if (result.data.deferred && result.data.deferred == 1)
                                showWarningMessage("Утм в данный момент недоступен. Акт поставлен в очередь. Отправится, когда заработает утм.");
                            else {
                                api.setView('WelcomeView');
                                showWelcomeView();
                                showSuccessMessage("Акт успешно отправлен.");
                            }
                        }
                        else {
                            showErrorMessage(result.message);
                        }
                    });
                } catch(e) {
                    showErrorMessage("При отправки акта произошла ошибка, попробуйте обновить страницу.");
                    hideAlerts();
                } finally {
                    clearInterval(timerId);
                    $("#buttonSend").button('reset');
                }
            } else {
                hideAlerts();

                if(res.code == 0) {
                    api.setView('WelcomeView');
                    showWelcomeView();
                    showSuccessMessage("Акт успешно сохранен.");
                }
                else {
                    showErrorMessage(res.message);
                }
            }
        });
    } catch (e) {
        if(sendFlag) {
            showErrorMessage("При отправки акта произошла ошибка, попробуйте обновить страницу.");
            hideAlerts();

            clearInterval(timerId);
            $("#buttonSend").button('reset');
        } else {
            showErrorMessage("При сохранении акта произошла ошибка, попробуйте обновить страницу.");
            hideAlerts();
        }
    } finally {
        if(!sendFlag) {
            clearInterval(timerId);
            $("#buttonSave").button('reset');
        }
    }
}

function parseDataPositionsListGrid(data){
    var result = [];
    var stamps;

//    перебираем список позиций
    for (var i = 0; i < data.length; i++) {
//        получаем массив фед. марок для позиции
        var stampsData = STAMPS_LIST_FOR_POS[data[i].id];
        stamps = [];
//перебираем этот массив и сохраняем в переменной stamps
        for (var j = 0; j < stampsData.length; j++) {
            stamps.push(stampsData[j].name);
        }

        result.push({
            identity: i+1,
            quantity: data[i].quantity,
            currFormBRegId: "",
            product: {
                producer: {
                    inn: data[i].producer_inn,
                    kpp: data[i].producer_kpp,
                    clientRegId: data[i].producer_client_reg_id,
                    fullName: data[i].producer_name,
                    shortName: data[i].producer_name
                },
                importer: {
                    inn: data[i].importer_inn,
                    kpp: data[i].importer_kpp,
                    clientRegId: data[i].importer_client_reg_id,
                    fullName: data[i].importer_name,
                    shortName: data[i].importer_name
                },
                name: data[i].name,
                capacity: data[i].capacity,
                egaisCode: data[i].alc_code,
                productCode: data[i].product_v_code
            },
            informA: INFO_FORM_A[data[i].id],
            fmarks: stamps
        });
    }
    return result;
}

function resizeSplitter() {
    var verticalSplitter = $("#splitter").data("kendoSplitter");
    var horizontalSplitter = $("#horizontal").data("kendoSplitter");

    if (horizontalSplitter) {
        if (window.innerWidth >= '768') {
            horizontalSplitter.orientation = horizontalSplitter.options.orientation = "horizontal";
            horizontalSplitter.element
                .children(".k-splitbar").remove()
                .end()
                .children(".k-pane").css({width: "", height: "", top: "", left: ""});

            horizontalSplitter.size(".k-pane:first", "50%");
            verticalSplitter.size(".k-pane:first", "45%");
            verticalSplitter.wrapper.height(700);
        }
        else {
            horizontalSplitter.orientation = horizontalSplitter.options.orientation = "vertical";
            horizontalSplitter.element
                .children(".k-splitbar").remove()
                .end()
                .children(".k-pane").css({width: "", height: "", top: "", left: ""});

            horizontalSplitter.size(".k-pane:first", "50%");
            verticalSplitter.size(".k-pane:first", "60%");
            verticalSplitter.wrapper.height(1000);
        }

        horizontalSplitter.resize();
        verticalSplitter.resize();
    }
}