var validatableFormActWrtOf,
    objAct,
    objCreateAct;

var editFlag, actType, formKind;

var STAMP_DEL_ICON = "delete.png",
    POS_ADD_ICON = "plus-icon.png";

var showEgaisCreateActWrtOfView = function(editAct) {
    var view = new kendo.View($('#EgaisCreateActWrtOfViewTemplate').html());
    layout.showIn("#content", view);
    kendo.culture("ru-RU");

    objAct = {};
    objCreateAct = {};

    editFlag = (typeof editAct == "object") ? true : false;
    actType = editFlag ? editAct.id_type : editAct;
    formKind = (actType == 5 || actType == 7) ? false : true;

    if(!editFlag)
        api.setView('EgaisCreateActWrtOfView', actType);

    viewModel.actFormTitle = (!editFlag && actType == 5) ? "Акт списания" :
        (!editFlag && actType == 7) ? "Акт списания из торгового зала" :
            (!editFlag && actType == 8) ? "Акт передачи в торговый зал" :
                (!editFlag && actType == 9) ? "Акт передачи на склад" :
                    (editFlag && actType == 5) ? "Редактирование акта списания" :
                        (editFlag && actType == 7) ? "Редактирование акта списания из торгового зала" :
                            (editFlag && actType == 8) ? "Редактирование акта передачи в торговый зал" :
                                (editFlag && actType == 9) ? "Редактирование акта передачи на склад" : "";

    viewModel.actFormNumber = editFlag && editAct.act_num ? (" № " + editAct.act_num) : "";
    viewModel.actId = editFlag ? editAct.id : null;
    kendo.bind($("span"), viewModel);

    //    Загрузка формы
    var layoutForm = new kendo.Layout("<section id='containerForm'></section>");
    layoutForm.render($("#formActWrtOf"));
    var viewForm;

    if(!formKind)
        viewForm = new kendo.View($('#formActWrtOfViewTemplate').html());
    else
        viewForm = new kendo.View($('#formActShopFloorViewTemplate').html());
    layoutForm.showIn("#containerForm", viewForm);
//    ------------------------

    if(!formKind) {
        $("#dropdownCause").kendoDropDownList({
            dataSource: {
                data: (actType == 5) ? [ 'Арест', 'Иные цели', 'Недостача', 'Пересортица', 'Порча', 'Потери', 'Проверки', 'Уценка' ] :
                    [ 'Арест', 'Иные цели', 'Недостача', 'Пересортица', 'Порча', 'Потери', 'Проверки', 'Реализация', 'Уценка' ]
            }
        });
    }

    var defaultDate = new Date();
    defaultDate = new Date(defaultDate.getFullYear(), defaultDate.getMonth(), defaultDate.getDate());

    $("#actDate").kendoDatePicker({
        format: "dd.MM.yyyy",
        value: defaultDate
    });
    $("#actDate").attr("readonly", "readonly");

    $("#buttonSend").kendoButton({
        click: function() {
            createActWrtOf(true);
        }
    });

    $("#buttonSave").kendoButton({
        enable: false,
        click: function() {
            createActWrtOf();
        }
    });

    var splitter = $("#splitter").kendoSplitter({
        orientation: "vertical",
        panes: [
            { size: "45%", scrollable: false, collapsible: true, collapsedSize: "20%"},
            { size: "55%", scrollable: false, collapsible: true }
        ]
    }).data("kendoSplitter");
    splitter.wrapper.height(700);
    splitter.resize();

    DATA_SOURCE_POS_LIST = new kendo.data.DataSource({
        data: [],
        schema: {
            model: {
                fields: {

                }
            }
        }
    });

    $("#positionsListGrid").kendoGrid({
        dataSource: DATA_SOURCE_POS_LIST,
        filterable: false,
        resizable: true,
        sortable: false,
        selectable: "multiple, row",
        height: "100%",
        toolbar: [
            { template: kendo.template($("#toolbarPosListGrid").html()) }
        ],
        columns: [
            { field: "identity", title: "№", width: 40, filterable: false,
                template: function(dataItem){
                    var ds = $("#positionsListGrid").data("kendoGrid").dataSource,
                        index = ds.indexOf( dataItem );
                    return index + 1;
                }
            },

            { field: "name", title: "Наименование", attributes:{ "class": "table-cell" }, width: 230 },
            { field: "capacity", title: "Объем", width: 70, filterable: false,
                template: function(dataItem) {
                    return dataItem.capacity ? kendo.toString(dataItem.capacity / 1000, "n2") + " л" : "не фас.";
                }
            },
            { field: "currFormARegId", title: "Справка А", width: 210, hidden: (actType == 7 || actType == 9) ? true : false,
                template: function(dataItem) {
                    return dataItem.form_a_reg_id;
                }
            },
            { field: "currFormBRegId", title: "Справка Б", width: 210, hidden: actType == 7 ? true : false,
                template: function(dataItem) {
                    return dataItem.form_b_reg_id;
                }
            },
            { field: "quantity", title: "Кол-во", width: 90, filterable: false,
                template: function(dataItem) {
                    return dataItem.capacity == 0 ? (kendo.toString(dataItem.quantity / 10000, "n3") + " дал") :
                        dataItem.quantity;
                }
            }
        ],
        editable: {
            mode: "incell",
            confirmation: false
        },
        edit: function(e) {
//            if (e.model.isNew()) {
            var grid = $("#positionsListGrid").data("kendoGrid"),
                row = grid.select(),
                dataItem = grid.dataItem(row);

            var numeric = e.container.find("input[name=quantity]").data("kendoNumericTextBox");
            if(numeric){
                var quantity, quantityNew;
                if(dataItem.capacity == 0) {
                    numeric.options.format = "n3";
                    numeric.options.decimals = 3;
                    quantity = dataItem.qty / 10000;

                    quantityNew = dataItem.quantity / 10000;
                    numeric.value(quantityNew);
                } else {
                    numeric.options.format = "n0";
                    numeric.options.decimals = 0;
                    quantity = dataItem.qty;
                }

                numeric.max(quantity);

                numeric.bind("change", function(){
                    if(dataItem.capacity == 0) {
                        dataItem.quantity  = this.value() * 10000;
                    }
                    grid.saveRow();
                });
            }
//            }
        },
        dataBound: function() {
            var lenght = this.dataSource.data().length;
            $("#buttonSend").data("kendoButton").enable(lenght > 0 ? true : false);
        }
    }).data("kendoGrid");

    $("#positionsListGrid").kendoTooltip({
        filter: "td.table-cell:not(:empty)",
        position: "right",
        animation: {
            open: {
                effects: "fade:in",
                duration: 200
            }
        },
        showAfter: 400,
        content: function(e) {
            var target = e.target;
            var content = target.text();
            return content;
        }
    }).data("kendoTooltip");

    $('#btnDelPos').kendoButton({
        imageUrl: "assets/icons/pays/" + STAMP_DEL_ICON,
        click: function() {
            var grid = $("#positionsListGrid").data("kendoGrid");
            var selectedRows = grid.select();

            for (var i = 0; i < selectedRows.length; i++) {
                grid.removeRow(selectedRows[i]);
            }

            var grid = $("#storeListGrid").data("kendoGrid");
            grid.select(grid.select());
        }
    });

    //---------------------------------------------------
    $("#storeListGrid").kendoGrid({
        dataSource  : {
            data: [],
            schema: {
                model: {
                    id: "id_product",
                    fields: {
                        identity: { editable: false },
                        name: { editable: false },
                        capacity: { editable: false },
                        currFormARegId: { editable: false },
                        currFormBRegId: { editable: (actType == 9) ? true : false },
                        posPrice: {
                            type: "number",
                            validation: {
                                min: 0
                            }
                        },
                        quantity: {
                            type: "number",
                            validation: {
                                min: 0
                            }
                        },
                        summa: { type: "number", editable: false }
                    }
                }
            }
        },
        filterable: {
            messages: {
                and: "и",
                or: "или",
                filter: "Фильтр",
                clear: "Очистить",
                info: "Фильтр по значению:"
            },
            operators: {
                string: {
                    eq: "Равно",
                    neq: "Не равно",
                    contains: "Содержит",
                    doesnotcontain: "Не содержит",
                    startswith: "Начинается на",
                    endswith: "Заканчивается на",
                    isempty: "Пустые",
                    isnotempty: "Не пустые"
                },
                number: {
                    eq: "=",
                    neq: "!=",
                    gt: ">",
                    lt: "<",
                    gte: ">=",
                    lte: "<=",
                    isnull: "Null",
                    isnotnull: "!Null"
                }
            },
            extra: false
        },
        resizable: true,
        sortable: true,
        selectable: "row",
        height: "100%",
        pageable: {
            pageSize: 20,
            pageSizes: true
        },
        toolbar: [
            { template: kendo.template($("#toolbarActStoreListGrid").html()) }
        ],
        columns: [
            { field: "id_product", title: "ID", width: 50, filterable: false, hidden: true },
            { field: "product_v_code", title: "Группа", width: 70, filterable: false },
            { field: "name", title: "Наименование", attributes:{ "class": "table-cell" }, width: 230, filterable: true },
            { field: "capacity", title: "Объем", width: 70, filterable: false,
                template: function(dataItem) {
                    return dataItem.capacity ? kendo.toString(dataItem.capacity / 1000, "n2") + " л" : "не фас.";
                }
            },
            { field: "producer_name", title: "Производитель", attributes:{ "class": "table-cell" }, width: 180, filterable: true },
            { field: "producer_inn", title: "ИНН", width: 120, filterable: true },
            { field: "producer_kpp", title: "КПП", width: 120, filterable: true },
            { field: "importer_name", title: "Импортер", attributes:{ "class": "table-cell" }, width: 180, filterable: true },
            { field: "importer_inn", title: "ИНН", width: 120, filterable: true },
            { field: "importer_kpp", title: "КПП", width: 120, filterable: true },
            { field: "form_a_reg_id", title: "Справка А", width: 210, filterable: true, hidden: (actType == 7 || actType == 9) ? true : false },
            { field: "form_b_reg_id", title: "Справка Б", width: 210, filterable: true, hidden: (actType == 7 || actType == 9) ? true : false },
            { field: "qty", title: "Кол-во", width: 90, filterable: false,
                attributes:{ "class": "table-cell" },
                template: function(dataItem) {
                    return dataItem.capacity == 0 ? (kendo.toString(dataItem.qty / 10000, "n3") + " дал") :
                        dataItem.qty;
                }
            }
        ],
        change: function(e) {
            var button = $("#btnAddPos").data("kendoButton");

            var row = this.select();
            var dataItem = this.dataItem(row);

            var index = DATA_SOURCE_POS_LIST.indexOf(dataItem);
            if(index == -1){
                button.enable(true);
            } else {
                button.enable(false);
            }
        }
    }).data("kendoGrid");

    $("#inpSearch").keyup(function () {
        filterAllGrid(this, "storeListGrid");
    });
    $('#btnClean').kendoButton({
        icon: "arrowhead-w",
        click: function(){
            var grid = $("#storeListGrid").data("kendoGrid");
            grid.dataSource.filter({});

            $("#inpSearch").val("");
        }
    });
    $('#btnAddPos').kendoButton({
        imageUrl: "assets/icons/pays/" + POS_ADD_ICON,
        click: addRow
    });

    function addRow(event) {
        var grid = $("#storeListGrid").data("kendoGrid");
        var row = grid.select();
        var dataItem = grid.dataItem(row);

        var index = DATA_SOURCE_POS_LIST.indexOf(dataItem);
        if(index == -1){
            dataItem.quantity = dataItem.qty;
            if(actType == 9) { // если акт перевода на склад
                showInfoFormBDialogView(dataItem);    // открываем диалог ввода спраки Б
            } else {
                DATA_SOURCE_POS_LIST.insert(0, dataItem);
            }
        }
    }

    var storeListGrid = $("#storeListGrid").data("kendoGrid");
    storeListGrid.bind("dataBound", function(){
        this.table.find("tr[data-uid]").dblclick(addRow);

        var button = $("#btnAddPos").data("kendoButton");
        button.enable(false);
    });
    storeListGrid.dataSource.fetch();

    $("#storeListGrid").kendoTooltip({
        filter: "td.table-cell:not(:empty)",
        position: "right",
        animation: {
            open: {
                effects: "fade:in",
                duration: 200
            }
        },
        showAfter: 400,
        content: function(e) {
            var target = e.target;
            var content = target.text();
            return content;
        }
    }).data("kendoTooltip");

    $(".k-button-toolbar").kendoTooltip({
        callout: false,
        position: "top"
    });

    reloadStoreList();
    refreshControlsActWrtOf(editAct);

    function reloadStoreList(){
        showProcessAlert("Загрузка склада");
        kendo.ui.progress($("#storeListGrid"), true);
        clearInterval(timerId);
        timerId = dotted();

        try {
            channel.objects.utm_server.getStore(function (response) {
                hideAlerts();
                if(response.code == 0) {
                    var grid = $("#storeListGrid").data("kendoGrid");
                    var data = response.data.store;
//                    var data = jsondata;

                    var storeKind = (actType == 7 || actType == 9) ? STOREKIND_SHOP_FLOOR : STOREKIND_STOCK;
                    var filterData = filterOnStoreKind(data, storeKind);

                    for (var i = 0; i < filterData.length; i++) {
                        filterData[i].quantity = filterData[i].qty;
                    }

                    grid.dataSource.data(filterData);
                    grid.refresh();

                    if(editFlag)
                        refreshPositionsActWrtOf(editAct.id, filterData);
                } else {
                    showErrorMessage(response.message ? response.message : "Неизвестная ошибка.");
                    showErrorAlert("Не удалось загрузить состояние склада, попробуйте обновить страницу.");
                }
            });
        } catch(e) {
            showErrorAlert("<strong>Не удалось загрузить состояние склада, попробуйте обновить страницу.</strong>");
        } finally {
            clearInterval(timerId);
            kendo.ui.progress($("#storeListGrid"), false);
        }
    }

    validatableFormActWrtOf = $("#formActWrtOf").kendoValidator({
        validateOnBlur: false,
        messages: {
            required: function(input){
                return input.data("message");
            }
        }
    }).data("kendoValidator");
}

function refreshControlsActWrtOf(editAct){
    var comment = "", cause = "";
    var comm;
    var dropdownlist;

    if(!editFlag) {
        try {
            var obj = {
                type: actType
            };
            channel.objects.utm_server.createStoreAct(obj, function (res) {
                if(res.code == 0) {
                    objCreateAct = res.data;
//                    console.log(JSON.stringify(objCreateAct));

                    $("#actNumber").val(objCreateAct.num);
                    $("#buttonSave").data("kendoButton").enable(true);

                    if(!formKind) {
                        comm = objCreateAct.comment;
                        if (comm) {
                            comment = comm.substring(comm.indexOf("|") + 1);
                            cause = comm.substring(0, comm.indexOf("|"));
                        }

                        $("#actComment").val(comment);

                        dropdownlist = $("#dropdownCause").data("kendoDropDownList");
                        dropdownlist.value(cause);
                        dropdownlist.trigger("change");
                    } else {
                        $("#actComment").val(objCreateAct.comment ? objCreateAct.comment : "");
                    }
                }
                else {
                    showErrorMessage(res.message);
                }
            });
        } catch (e) {
            showErrorMessage("При создании акта произошла ошибка, попробуйте обновить страницу.");
        }
    } else {
        $("#actNumber").val(editAct.act_num ? editAct.act_num : "");
        $("#buttonSave").data("kendoButton").enable(true);

        if(!formKind) {
            comm = editAct.comment;
            if (comm) {
                comment = comm.substring(comm.indexOf("|") + 1);
                cause = comm.substring(0, comm.indexOf("|"));
            }

            $("#actComment").val(comment);

            dropdownlist = $("#dropdownCause").data("kendoDropDownList");
            dropdownlist.value(cause);
            dropdownlist.trigger("change");
        } else {
            $("#actComment").val(editAct.comment ? editAct.comment : "");
        }
    }
}

function refreshPositionsActWrtOf(actId, store){
    try {
        var obj = {
            id: actId
        };
        channel.objects.utm_server.getActPositions(obj, function (res) {
            if(res.code == 0) {
                var posList = res.data;

                var storeGrid = $("#storeListGrid").data("kendoGrid");
                var posGrid = $("#positionsListGrid").data("kendoGrid");

                for (var i = 0; i < posList.length; i++) {
                    for (var j = 0; j < store.length; j++) {
                        if (((actType == 5 || actType == 8) && posList[i].curr_form_b_reg_id == store[j].form_b_reg_id) ||
                            ((actType == 7 || actType == 9) && posList[i].alc_code == store[j].alc_code)) {

                            var dataItem = storeGrid.dataSource.get(store[j].id_product);
                            var index = posGrid.dataSource.indexOf(dataItem);
                            if (index == -1) {
                                dataItem.quantity = Math.min(dataItem.qty, posList[i].qty);
                                if(actType == 9)
                                    dataItem.form_b_reg_id = posList[i].curr_form_b_reg_id;
                                posGrid.dataSource.add(dataItem);
                            }

                            break;
                        }
                    }
                }
            } else {
                showErrorMessage(res.message);
            }
        });
    } catch(e) {
        showErrorMessage("Не удалось загрузить список позиций акта, попробуйте обновить страницу.");
    }
}

function createActWrtOf(sendFlag){
    var validField = true;
    if(!formKind)
        validatableFormActWrtOf.validateInput($("input[name=cause]"))

    if (validatableFormActWrtOf.validateInput($("input[name=number]")) & validField) {
        hideAlerts();

        var actDate = $("#actDate").data("kendoDatePicker");
        var posList = parseDataPosGridActWrt($("#positionsListGrid").data("kendoGrid").dataSource.data());
        var cause = "";
        if(!formKind)
            cause = $("#dropdownCause").data("kendoDropDownList").value() + "|";

        objAct = {
            actType: actType,
            num: $("#actNumber").val(),
            actDate: new Date(actDate.value()).toISOString(),
            comment: cause + $("#actComment").val(),
            positions: posList
        };

        if(sendFlag) {
            confirmMessageDialog.open().center();

            var viewModelConfirmDialog = kendo.observable({
                message: "После отправки в УТМ акт будет недоступен для редактирования.",
                cancel: function () {
                    confirmMessageDialog.close();
                },
                continue: function () {
                    confirmMessageDialog.close();
                    creatingActWrtOf(true);
                }
            });
            kendo.bind($("#confirmMessageDialog"), viewModelConfirmDialog);

        } else {
            creatingActWrtOf();
        }

    } else {
        showWarningMessage("Не заполнены обязательные поля.");
    }
}

function creatingActWrtOf(sendFlag){
//    console.log(JSON.stringify(objAct));
    if(!editFlag) {
        $.extend(objCreateAct, objAct);
        objAct = objCreateAct;
    } else {
        objAct.id = viewModel.actId;
    }
    saveActWrtOf(sendFlag);
};

function saveActWrtOf(sendFlag){
    showProcessAlert((sendFlag ? "Отправка" : "Сохранение") + " акта");
    if(sendFlag)
        $("#buttonSend").button('loading');
    else
        $("#buttonSave").button('loading');
    clearInterval(timerId);
    timerId = dotted();

    try {
        channel.objects.utm_server.saveStoreAct(objAct, function(res){
            if(sendFlag){
                var id = { id: objAct.id };
                try {
                    channel.objects.utm_server.sendStoreAct(id, function (result) {
                        hideAlerts();

                        if (result.code == 0) {
                            if (result.data.deferred && result.data.deferred == 1)
                                showWarningMessage("Утм в данный момент недоступен. Акт поставлен в очередь. Отправится, когда заработает утм.");
                            else {
                                api.setView('ActListView');
                                showActListView();
                                showSuccessMessage("Акт успешно отправлен.");
                            }
                        }
                        else {
                            showErrorMessage(result.message);
                        }
                    });
                } catch(e) {
                    showErrorMessage("При отправке акта произошла ошибка, попробуйте обновить страницу.");
                    hideAlerts();
                } finally {
                    clearInterval(timerId);
                    $("#buttonSend").button('reset');
                }
            } else {
                hideAlerts();

                if(res.code == 0) {
                    api.setView('ActListView');
                    showActListView();
                    showSuccessMessage("Акт успешно сохранен.");
                }
                else {
                    showErrorMessage(res.message);
                }
            }
        });
    } catch (e) {
        if(sendFlag) {
            showErrorMessage("При отправке акта произошла ошибка, попробуйте обновить страницу.");
            hideAlerts();

            clearInterval(timerId);
            $("#buttonSend").button('reset');
        } else {
            showErrorMessage("При сохранении акта произошла ошибка, попробуйте обновить страницу.");
            hideAlerts();
        }
    } finally {
        if(!sendFlag) {
            clearInterval(timerId);
            $("#buttonSave").button('reset');
        }
    }
}

function parseDataPosGridActWrt(data){
    var result = [];

//    перебираем список позиций
    for (var i = 0; i < data.length; i++) {
        result.push({
            identity: i+1,
            quantity: data[i].quantity,
            currFormBRegId: (actType == 5 || actType == 8 || actType == 9) ? data[i].form_b_reg_id : "",
            product: {
                producer: {
                    inn: data[i].producer_inn,
                    kpp: data[i].producer_kpp,
                    clientRegId: "",//data[i].producer_client_reg_id,
                    fullName: data[i].producer_name,
                    shortName: data[i].producer_name
                },
                importer: {
                    inn: data[i].importer_inn,
                    kpp: data[i].importer_kpp,
                    clientRegId: "",//data[i].importer_client_reg_id,
                    fullName: data[i].importer_name,
                    shortName: data[i].importer_name
                },
                name: data[i].name,
                capacity: data[i].capacity,
                egaisCode: "",//data[i].alc_code,
                productCode: data[i].product_v_code
            }
        });
    }
    return result;
}