var TTN_ACCEPT_STATE_NEW = 0,
    TTN_ACCEPT_STATE_CONSIDERATION = 1,
    TTN_ACCEPT_STATE_ACCEPTED = 2,
    TTN_ACCEPT_STATE_REJECTED = 3,
    TTN_ACCEPT_STATE_REVOKED = 4,
    TTN_ACCEPT_STATE_DRAFT = 5,
    TTN_ACCEPT_STATE_SENT = 6,

    TTN_TYPE_PURCHASE = 1,
    TTN_TYPE_RETURN = 2,
    TTN_TYPE_EXPENSE = 3;

var EDIT_TTN_ICON = "edit-icon.png",
    RETURN_ICON = "return-icon.png";

var getTtnAcceptStateClass = function (status) {
    return (status == TTN_ACCEPT_STATE_NEW) ? "csNotCheckedBoxLabel" :
        (status == TTN_ACCEPT_STATE_CONSIDERATION) ? "csRevokedBoxLabel" :
            (status == TTN_ACCEPT_STATE_ACCEPTED) ? "csAcceptBoxLabel" :
                (status == TTN_ACCEPT_STATE_REJECTED) ? "csErrorBoxLabel" :
                    (status == TTN_ACCEPT_STATE_REVOKED) ? "csWaitBoxLabel" :
                        (status == TTN_ACCEPT_STATE_DRAFT) ? "csDraftBoxLabel" :
                            (status == TTN_ACCEPT_STATE_SENT) ? "csSentBoxLabel" : "";
};

var getTtnAcceptStateText = function (status) {
    return (status == TTN_ACCEPT_STATE_NEW) ? "новая" :
        (status == TTN_ACCEPT_STATE_CONSIDERATION) ? "в работе" :
            (status == TTN_ACCEPT_STATE_ACCEPTED) ? "проведена" :
                (status == TTN_ACCEPT_STATE_REJECTED) ? "отклонена" :
                    (status == TTN_ACCEPT_STATE_REVOKED) ? "отозвана" :
                        (status == TTN_ACCEPT_STATE_DRAFT) ? "черновик" :
                            (status == TTN_ACCEPT_STATE_SENT) ? "отправлена" : "";
};

var getTtnTypeText = function (type) {
    return (type == TTN_TYPE_PURCHASE) ? "Приход" :
        (type == TTN_TYPE_RETURN) ? "Возврат" :
            (type == TTN_TYPE_EXPENSE) ? "Расход" : "";
}

var GREEN_ICON = "ball_green.png",
    RED_ICON =  "ball_red.png",
    GREY_ICON = "ball_glass_grey.png",
    BLUE_ICON = "ball_blue.png",
    ABORT_ICON = "abort-icon.png";

var getTtnStatus = function(dataItem){
    var returnStringTemplate = "";
    var tooltip = "";
    if (dataItem.status == 0){
        returnStringTemplate = "<img src='assets/icons/pays/" + RED_ICON + "'></img>";
        tooltip = "Не отправлена на сервер";
    }
    else if (dataItem.status == 1){
        returnStringTemplate = "<img src='assets/icons/pays/" + GREEN_ICON + "'></img>";
        tooltip = "Успешно обработана на сервере";
    }
    else if (dataItem.status == 2){
        returnStringTemplate = "<img src='assets/icons/pays/" + ABORT_ICON + "'></img>";
        tooltip = "Ошибка обработки на сервере";
    }
    else if (dataItem.status == 3){
        returnStringTemplate = "<img src='assets/icons/pays/" + BLUE_ICON + "'></img>";
        tooltip = "Получена на сервере";
    }
    else if (dataItem.status == 4){
        returnStringTemplate = "<img src='assets/icons/pays/" + GREY_ICON + "'></img>";
        tooltip = "Отправлена на сервер";
    }

    return "<div class='container-status text-center' title='" + tooltip +"'>" + returnStringTemplate + "</div>";
}



var filterTtnList = function(srcData){
    if (ttnFilterValues == -1)
        return srcData;

    var res = [];
    var filteredIndex = 0;
    for (var i = 0; i < srcData.length; i++){
        if ((srcData[i].accept_state != undefined) && (srcData[i].accept_state == ttnFilterValues)){
            res[filteredIndex] = (srcData[i]);
            filteredIndex++;
        }
    }

    return res;
}

var reloadTtnList = function(){
    showProcessAlert("Загрузка списка ТТН");

    $("#refreshButton").button('loading');
    clearInterval(timerId);
    timerId = dotted();

    try {
        channel.objects.utm_server.getClientDocs("all", function (clientDocsResp) {
            hideAlerts();
//var data = [
//    {
//        "accept_state":1,
//        "act_type":"Подтверждение, отклонен",
//        "base":"",
//        "comment":"",
//        "consignee_name":"Курская обл, , Курск г, , Магистральный проезд', 13, , А,",
//        "consignee_address":"Курская обл, , Курск г, , Магистральный проезд', 13, , А,",
//        "doc_date":"2015-12-17",
//        "doc_id":1,
//        "doc_num":"00000049047",
//        "doc_type":1,
//        "id_consignee":2,
//        "id_new_doc":"",
//        "id_shipper":1,
//        "id_supplier":3,
//        "price_total":1704000,
//        "qty_total":100,
//        "shipper_inn":"4632085239",
//        "shipper_kpp":"463245002",
//        "shipper_name":"ООО 'ПК Кристалл-Лефортово'",
//        "status":1,
//        "status_date":"2016-09-05T16:05:21.413",
//        "ticket_comment":"",
//        "vol_total":50000,
//        "wbreg_id":"TEST-TTN-0000447431"
//    },
//    {
//        "accept_state":5,
//        "act_type":"",
//        "base":"",
//        "comment":"",
//        "consignee_name":"",
//        "doc_date":"2016-09-06",
//        "doc_id":2,
//        "doc_num":"",
//        "doc_type":3,
//        "id_consignee":3,
//        "id_new_doc":"",
//        "id_shipper":2,
//        "id_supplier":3,
//        "price_total":"",
//        "qty_total":"",
//        "shipper_inn":"4630001096",
//        "shipper_kpp":"463201001",
//        "shipper_name":"ООО 'Магазин №123 Продтовары' (магазин 'Продукты')",
//        "status":100,
//        "status_date":"2016-09-06T12:12:43.482",
//        "ticket_comment":"",
//        "vol_total":"",
//        "wbreg_id":""
//    }
//];
            var grid = $("#egaisTtnListGrid").data("kendoGrid");
//            grid.dataSource.data(filterTtnList(testDocList(data)));
            grid.dataSource.data(filterTtnList(testDocList(clientDocsResp.data)));
            grid.refresh();

            if (grid.dataSource.total() == 0){
                if(ttnFilterValues == -1)
                    showInfoAlert("Список ТТН пуст");
                else
                    showInfoAlert("Не найдено накладных по заданным параметрам");
            }
        });
    } catch(e) {
        showErrorAlert("<strong>Соединение потеряно или истекло время сессии, попробуйте обновить страницу</strong>");
    } finally {
        clearInterval(timerId);
        $("#refreshButton").button('reset');
    }
}

var showEgaisTtnListView = function() {

    //Если наружу то происходит дублирование
    var egaisTtnListView = new kendo.View($('#egaisTtnListViewTemplate').html());

    layout.showIn("#content", egaisTtnListView);
    //egaisTtnListViewTemplate
    ttnFilterValues = -1;

    $("#refreshButton").kendoButton({
        icon: "refresh",
        click: function(){
            reloadTtnList();
        }
    });

    $("#egaisTtnListFilterMenu").kendoToolBar({
        items: [
            { id: "ttnFilterAll", type: "button", text: "все", group : "ttnFilterGroup", togglable: true, selected: true },
            { type: "separator" },
            { id: "ttnFilterNew", type: "button", text: "новые", group : "ttnFilterGroup", togglable: true, selected: false },
            { id: "ttnFilterConsideration", type: "button", text: "в работе", group : "ttnFilterGroup", togglable: true, selected: false },
            { id: "ttnFilterAccepted", type: "button", text: "проведены", group : "ttnFilterGroup", togglable: true, selected: false },
            { id: "ttnFilterRejected", type: "button", text: "отклонены", group : "ttnFilterGroup", togglable: true, selected: false },
            { id: "ttnFilterRevoked", type: "button", text: "отозваны", group : "ttnFilterGroup", togglable: true, selected: false },
            { id: "ttnFilterDraft", type: "button", text: "черновики", group : "ttnFilterGroup", togglable: true, selected: false },
            { id: "ttnFilterSent", type: "button", text: "отправлены", group : "ttnFilterGroup", togglable: true, selected: false }
        ],

        toggle: function(e) {
            var code = (e.id == "ttnFilterNew") ? TTN_ACCEPT_STATE_NEW :
                (e.id == "ttnFilterConsideration") ? TTN_ACCEPT_STATE_CONSIDERATION :
                    (e.id == "ttnFilterAccepted") ? TTN_ACCEPT_STATE_ACCEPTED :
                        (e.id == "ttnFilterRejected") ? TTN_ACCEPT_STATE_REJECTED :
                            (e.id == "ttnFilterRevoked") ? TTN_ACCEPT_STATE_REVOKED :
                                (e.id == "ttnFilterDraft") ? TTN_ACCEPT_STATE_DRAFT :
                                    (e.id == "ttnFilterSent") ? TTN_ACCEPT_STATE_SENT :
                                        "-1";

            ttnFilterValues = code;

            reloadTtnList();
        }
    });

//    var _jsondata = [];
//    for(var i=0; i < 10; i++) {
//        _jsondata.push({
//            doc_num: "00000000" + i, doc_date: "Thu Dec 17 2015 03:00:00 GMT+0300 (MSK)",
//            shipper_inn: "3911008754", shipper_kpp: "390601001",
//            shipper_name: "ООО ГИФТ", status: i%5,
//            doc_type: i%3 + 1,
//            ticket_comment: (i%2 == 0) ? "ticket_comment" : "",
//            accept_state: (i%7),
//            id_shipper: i+10,
//            act_type: "wefewfew"
//        });
//    }

    $("#egaisTtnListGrid").kendoGrid({
        dataSource: {
            data : [],
            schema: {
                model: {
                    fields: {
                        doc_date: { type: "date" }
                    }
                }
            }
        },
//                    height: 700,
        minHeight : 400,
        filterable: {
            extra: false,
            messages: {
                and: "и",
                or: "или",
                filter: "Фильтр",
                clear: "Очистить",
                info: "Фильтр по значению:",
                selectedItemsFormat: "Выбрано {0} элементов",
                checkAll: "Выбрать Всё"
            },
            operators: {
                string: {
                    contains: "Содержит",
                    eq: "Равно",
                    neq: "Не равно",
                    doesnotcontain: "Не содержит",
                    startswith: "Начинается на",
                    endswith: "Заканчивается на",
                    isempty: "Пустые",
                    isnotempty: "Не пустые"
                },
                number: {
                    eq: "=",
                    neq: "!=",
                    gt: ">",
                    lt: "<",
                    gte: ">=",
                    lte: "<=",
                    isnull: "Null",
                    isnotnull: "!Null"
                },
                date: {
                    gte: "после или равна",
                    gt: "после",
                    lte: "до или равна",
                    lt: "до"
                }
            }
        },
        groupable: true,
        resizable: true,
        sortable: true,
        selectable: "row",
        pageable: {
            pageSizes: true,
            pageSize : 50
        },
        columns: [
            {
                field: "edit_doc",
                template: function(dataItem) {
                    return (dataItem.accept_state != undefined && dataItem.accept_state == TTN_ACCEPT_STATE_DRAFT) ?
                        "<div class='container-status k-edit-doc text-center' title='Редактировать накладную'>" +
                        "<img width='16' height='16' src='assets/icons/pays/" +
                            EDIT_TTN_ICON +"'></img></div>" : "";
                },
                title: "Редактирование накладной", width: 30, filterable: false, sortable: false,
                headerTemplate: ""
            },
            {
                field: "return_doc",
                template: function(dataItem) {
                    return (dataItem.doc_type != undefined && dataItem.doc_type == TTN_TYPE_PURCHASE) ?
                        "<div class='container-status k-return-doc text-center' title='Создать возврат'>" +
                        "<img width='16' height='16' src='assets/icons/pays/" +
                            RETURN_ICON +"'></img></div>" : "";
                },
                title: "Возврат накладной", width: 30, filterable: false, sortable: false,
                headerTemplate: ""
            },
            {
                field: "delete_doc",
                template: function(dataItem) {
                    return (dataItem.accept_state != undefined && dataItem.accept_state == TTN_ACCEPT_STATE_DRAFT &&
                        dataItem.doc_type != undefined && (dataItem.doc_type == TTN_TYPE_RETURN || dataItem.doc_type == TTN_TYPE_EXPENSE)) ?
                        "<div class='container-status k-delete-doc text-center' title='Удалить накладную'>" +
                        "<img width='16' height='16' src='assets/icons/pays/delete.png'></div>" : "";
                },
                title: "Удаление накладной", width: 30, filterable: false, sortable: false,
                headerTemplate: ""
            },
            {
                field: "doc_num",
                title: "№ ТТН",
                width: 120,
                filterable: {
                    cell: {
                        operator: "contains",
                        template: function (args) {
                            args.element.css("width", "90%").addClass("k-textbox").keydown(function(e){
                                setTimeout(function(){
                                    $(e.target).trigger("change");
                                });
                            });
                        },
                        showOperators: false
                    }
                }
            },
            {
                field: "doc_date",
                title: "Дата ТТН",
                format: "{0: dd.MM.yyyy}",
                filterable: {
                    extra: true
                },
                width: 150
            },
            { field: "doc_type", title: "Тип ТТН", width: 110,
                template: "#: getTtnTypeText(doc_type) #",
                filterable: {
                    multi:true,
                    checkAll: true,
                    itemTemplate: function(e) {
                        return "<li class='k-item'>" +
                            "<label>" +
                                "<input type='checkbox' class='k-checkbox' name='" + e.field + "' value='#= data.doc_type#'/>" +
                                "<label class='k-checkbox-label check-label'></label>" +
                                "<span>#= getTtnTypeText(data.doc_type) || data.all #</span>" +
                            "</label></li>";
                    }
                }
            },
            {
                field: "accept_state",
                title: "Статус",
                width: 120,
//                            template: '<span class="#: getTtnAcceptStateClass(accept_state) # accepted-tooltip" title="#: ticket_comment #">#: getTtnAcceptStateText(accept_state) # </span>',
                template: function(dataItem) {
                    return dataItem.accept_state != undefined ?
                        "<span class='" + getTtnAcceptStateClass(dataItem.accept_state) + "'>" +
                            getTtnAcceptStateText(dataItem.accept_state) + "</span>" : "";
                },
                filterable: false
            },
            {
                field: "shipper_name",
                title: "Отправитель",
                attributes:{ "class": "table-cell" },
                width: 160
            },
            {
                field: "shipper_inn",
                title: "ИНН отпр.",
                width: 120
            },
            {
                field: "shipper_kpp",
                title: "КПП отпр.",
                width: 120
            },
            {
                field: "consignee_name",
                title: "Получатель",
                attributes:{ "class": "table-cell" },
                width: 160
            },
            {
                field: "status",
                title: "Синхр.",
                width: 70,
                filterable: false,
                template: getTtnStatus
//                            template: '<span class="#: getTtnStatusClass(status) #">#: getTtnStatusText(status) # </span>'
//                            filterable: {
//                                multi:true,
//                                messages: {
//                                    checkAll: "Показать все"
//                                },
//                                itemTemplate: function(e) {
//                                    return "<span>" +
//                                            "<label>" +
//                                            "<span>#= data.status || data.all #</span>"+
//                                            " <input type='checkbox' name='" + e.field + "' value='#= data.status#'/>" +
//                                            "</label><br/>" +
//                                            "</span>";
//                                }

//                            }

            },
            {
                field: "ticket_comment",
                title: "Комментарий",
                attributes:{ "class": "table-cell" },
                width: 130,
                filterable: false
            },
            {
                field: "act_type",
                title: "Акт",
                attributes:{ "class": "table-cell" },
                width: 140,
                hidden: true,
                filterable: false
            },
            {   field: "review",
                title : "Просмотр",
                width: 120,
                headerTemplate: "",
                filterable: false,
                template: function(dataItem) {
                    var text = "Просмотр";
                    if(dataItem.accept_state == TTN_ACCEPT_STATE_DRAFT) {
                        text = "Редактир.";
                    }

                    return "<button class='k-button k-review-doc'>" + text + "</button>";
                }
//                command: [{
//                    name: "showTtn",
//                    text: "Просмотр",
//                    click: function(e) {
//                        var tr = $(e.target).closest("tr");
//                        var data = this.dataItem(tr);
//
//                        if(data.accept_state == TTN_ACCEPT_STATE_DRAFT) {
//                            data["operation_type"] = 1;
//
//                            api.setView("WaybillCreateFormView", JSON.parse(JSON.stringify(data)));
//                            showWaybillCreateFormView(data);
//                            return false;
//                        }
//
//                        var dataObj = {
//                            doc_id: data.doc_id,
//                            doc_num: data.doc_num,
//                            doc_date: data.doc_date,
//                            shipper_name: data.shipper_name,
//                            doc_type: data.doc_type
//                        };
//
//                        api.setView("EgaisTtnInfoView", dataObj);
//                        showEgaisTtnInfoView(dataObj);
//                        return false;
//                    }
//                }]
            }
        ],
        dataBound: function() {
            this.table.find("tr[data-uid]").dblclick( function(){
                var row = $(this).closest("tr"),
                    grid = $("#egaisTtnListGrid").data("kendoGrid"),
                    data = grid.dataItem(row);

                if(data.accept_state == TTN_ACCEPT_STATE_DRAFT) {
                    data["operation_type"] = 1;

                    api.setView("WaybillCreateFormView", JSON.parse(JSON.stringify(data)));
                    showWaybillCreateFormView(data);
                    return;
                }

                api.setView("EgaisTtnInfoView", JSON.parse(JSON.stringify(data)));
                showEgaisTtnInfoView(data);
            });

            this.table.find(".k-edit-doc").click(function(){
                var row = $(this).closest("tr"),
                    grid = $("#egaisTtnListGrid").data("kendoGrid"),
                    dataItem = grid.dataItem(row);
                dataItem["operation_type"] = 1;

                api.setView("WaybillCreateFormView", JSON.parse(JSON.stringify(dataItem)));
                showWaybillCreateFormView(dataItem);
            });

            this.table.find(".k-review-doc").click(function(){
                var row = $(this).closest("tr"),
                    grid = $("#egaisTtnListGrid").data("kendoGrid"),
                    data = grid.dataItem(row);

                if(data.accept_state == TTN_ACCEPT_STATE_DRAFT) {
                    data["operation_type"] = 1;

                    api.setView("WaybillCreateFormView", JSON.parse(JSON.stringify(data)));
                    showWaybillCreateFormView(data);
                    return;
                }

                api.setView("EgaisTtnInfoView", JSON.parse(JSON.stringify(data)));
                showEgaisTtnInfoView(data);
            });

            this.table.find(".k-return-doc").click(function(){
                var row = $(this).closest("tr"),
                    grid = $("#egaisTtnListGrid").data("kendoGrid"),
                    dataItem = grid.dataItem(row);
                dataItem["operation_type"] = 2;

                api.setView("WaybillCreateFormView", JSON.parse(JSON.stringify(dataItem)));
                showWaybillCreateFormView(dataItem);
            });

            this.table.find(".k-delete-doc").click(function(){
                var row = $(this).closest("tr"),
                    grid = $("#egaisTtnListGrid").data("kendoGrid"),
                    dataItem = grid.dataItem(row);

                confirmMessageDialog.open().center();

                var viewModelConfirmDialog = kendo.observable({
                    message: "Удалить накладную?",
                    cancel: function () {
                        confirmMessageDialog.close();
                    },
                    continue: function () {
                        try{
                            var objId = {
                                id: dataItem.doc_id
                            };
                            channel.objects.utm_server.deleteWaybill(objId, function (result) {
                                if (result.code == 0) {
                                    reloadTtnList();
                                }
                                else {
                                    showErrorMessage(result.message);
                                }
                            });
                        } catch(e) {
                            showErrorMessage("Произошла ошибка, попробуйте обновить страницу.");
                        }
                        confirmMessageDialog.close();
                    }
                });
                kendo.bind($("#confirmMessageDialog"), viewModelConfirmDialog);
            });

            $(".container-status").kendoTooltip({
                callout: false,
                position: "top"
            });
            $(".accepted-tooltip").kendoTooltip({
                callout: false,
                position: "top"
            });
        },
        dataBinding: function() {
            this.thead.kendoTooltip({
                callout:false,
                position: "top",
                filter: "th",
                content: function (e) {
                    return $(e.target).attr("data-title");
                }
            });
        }
    });

    bindWinSet('#egaisTtnListView', "#egaisTtnListGrid", "cookieEgaisTtnList");

    $("#egaisTtnListGrid").kendoTooltip({
        filter: "td.table-cell:not(:empty)",
        position: "right",
        animation: {
            open: {
                effects: "fade:in",
                duration: 200
            }
        },
        showAfter: 400,
        content: function(e) {
            var target = e.target;
            var content = target.text();
            return content;
        }
    }).data("kendoTooltip");

//        kendo.fx($("#egaisTtnListView")).zoomIn().play();

    reloadTtnList();
    //Заглушка
//        var grid = $("#egaisTtnListGrid").data("kendoGrid");
//        var test = [{docId : 123, dt : "12-12-2015"},
//                    {docId : 555, dt : "14-12-2015"}];
//        grid.dataSource.data(test);
}