var showPersonsListView = function(){
    var view = new kendo.View($('#personsListViewTemplate').html());
    layout.showIn("#content", view);
    kendo.culture("ru-RU");

    $("#refreshButton").kendoButton({
        icon: "refresh",
        click: function(){
            reloadPersonsList();
        }
    });

    $("#personsListGrid").kendoGrid({
        dataSource  : {
            data: [],
            schema: {
                model: {
                    fields: {
                        id: { type: "number" }
                    }
                }
            }
        },
        filterable: {
            messages: {
                and: "и",
                or: "или",
                filter: "Фильтр",
                clear: "Очистить",
                info: "Фильтр по значению:"
            },
            operators: {
                string: {
                    eq: "Равно",
                    neq: "Не равно",
                    contains: "Содержит",
                    doesnotcontain: "Не содержит",
                    startswith: "Начинается на",
                    endswith: "Заканчивается на",
                    isempty: "Пустые",
                    isnotempty: "Не пустые"
                },
                number: {
                    eq: "=",
                    neq: "!=",
                    gt: ">",
                    lt: "<",
                    gte: ">=",
                    lte: "<=",
                    isnull: "Null",
                    isnotnull: "!Null"
                }
            },
            extra: false
        },
        groupable: true,
        resizable: true,
        reorderable: true,
        sortable: true,
        selectable: "row",
        pageable: {
            pageSize: 20,
            pageSizes: true
        },
        columns: [
            { field: "id", title: "ID", width: 50, filterable: false, hidden: true },
            { field: "clientRegId", title: "ФСРАР ID", attributes:{ "class": "table-cell" }, width: 160,
                template: function(dataItem) {
                    return dataItem.client_reg_id;
                }
            },
            { field: "name", title: "Контрагент", attributes:{ "class": "table-cell" }, width: 230 },
            { field: "inn", title: "ИНН", width: 120 },
            { field: "kpp", title: "КПП", width: 120 },
            { field: "address", title: "Адрес", attributes:{ "class": "table-cell" }, width: 250 }
        ],
        dataBound: function() {}
    }).data("kendoGrid");

    bindWinSet('#personsList', "#personsListGrid", "cookiePersonsList");

    $("#personsListGrid").kendoTooltip({
        filter: "td.table-cell:not(:empty)",
        position: "right",
        animation: {
            open: {
                effects: "fade:in",
                duration: 200
            }
        },
        showAfter: 400,
        content: function(e) {
            var target = e.target;
            var content = target.text();
            return content;
        }
    }).data("kendoTooltip");

    reloadPersonsList();

    function reloadPersonsList(){
        showProcessAlert("Загрузка списка контрагентов");

        $("#refreshButton").button('loading');
        clearInterval(timerId);
        timerId = dotted();

        try {
            channel.objects.utm_server.getPersons(function (response) {
                hideAlerts();

                var grid = $("#personsListGrid").data("kendoGrid");
                grid.dataSource.data(response.data);
                grid.refresh();

                if (grid.dataSource.total() == 0)
                    showInfoAlert("Не найдено ни одного контрагента");
            });
        } catch(e) {
            showErrorAlert("<strong>Соединение потеряно или истекло время сессии, попробуйте обновить страницу</strong>");
        } finally {
            clearInterval(timerId);
            $("#refreshButton").button('reset');
        }
    }
}