//const
var EDIT_ICON = "edit.png",
    EDIT_ACTIVE_ICON = "edit-active.png"
    DEL_ICON = "delete.png",
    ADD_ICON = "plus-icon.png",
    SAVE_ICON = "save.png",
    CANCEL_ICON = "cancel.png";

var edit_grid = false;
var isCreating = false;

//------------------ TOOLBAR --------------------------
//фильтр
function toolbar_filter_keyup(){
    filterAllGrid($("#inpSearch"), "productsListGrid");
}
//очистка фильтра
function toolbar_clean_click() {
    var grid = $("#productsListGrid").data("kendoGrid");
    grid.dataSource.filter({});

    $("#inpSearch").val("");
}
//edit position
function edit_click(o) {
    var row = $(o).closest("tr");
    var grid = $("#productsListGrid").data("kendoGrid");
    grid.editRow(row);
}
//delete position
function del_click(o) {
    var row = $(o).closest("tr");
    var grid = $("#productsListGrid").data("kendoGrid"),
    dataItem = grid.dataItem(row);

    confirmMessageDialog.open().center();

    var viewModelConfirmDialog = kendo.observable({
        message: "Удалить товар?",
        cancel: function () {
            confirmMessageDialog.close();
        },
        continue: function () {
            try{
                var objId = {
                    id: dataItem.id
                };
                channel.objects.utm_server.deleteProduct(objId, function (result) {
                    if (result.code == 0) {
                        reloadProductsList();
                    }
                    else {
                        showErrorMessage(result.message);
                    }
                });
            } catch(e) {
                showErrorMessage("Произошла ошибка, попробуйте обновить страницу.");
            }
            confirmMessageDialog.close();
        }
    });
    kendo.bind($("#confirmMessageDialog"), viewModelConfirmDialog);
}
//add position
function toolbar_add_click() {
    isCreating = true;
    var grid = $("#productsListGrid").data("kendoGrid");
    grid.addRow();
}

//reloadProductsList
function reloadProductsList(){
    showProcessAlert("Загрузка справочника товаров");

    kendo.ui.progress($("#productsListGrid"), true);
    $("#refreshButton").button('loading');
    clearInterval(timerId);
    timerId = dotted();

    try {
        channel.objects.utm_server.getProducts(function (response) {
            hideAlerts();

            if(response.code == 0) {
                var grid = $("#productsListGrid").data("kendoGrid");
                grid.dataSource.data(parseData(response.data));
//                grid.dataSource.data(parseData(jsondata));
                grid.refresh();

                if (grid.dataSource.total() == 0)
                    showInfoAlert("Справочник товаров пуст");
            }
            else {
                showErrorMessage(response.message);
            }
        });
    } catch(e) {
        showErrorAlert("<strong>Соединение потеряно или истекло время сессии, попробуйте обновить страницу</strong>");
    } finally {
        clearInterval(timerId);
        $("#refreshButton").button('reset');
        kendo.ui.progress($("#productsListGrid"), false);
    }
}

//тестовые данные
var jsondata = [];
for(var i=0; i< 20; i++)
    jsondata.push({
        "id": i+1,
        capacity: 100*i + 50,
        product_v_code: 200 * i,
        name: (i%2==0) ? "Водка русская" : "Водка столичная",
        producer_name: (i%6==0) ? "ООО Атлант" :
            (i%6==1) ? "Ника" :
                (i%6==2) ? "Союз" :
                    (i%6==3) ? "Россия" :
                        (i%6==4) ? "Путинка" :
                            "Nemiroff" ,
        producer_id: i+1,
        producer_client_reg_id: (i%6==0) ? "1" :
            (i%6==1) ? "2" :
                (i%6==2) ? "3" :
                    (i%6==3) ? "4" :
                        (i%6==4) ? "5" :
                            "6" ,
        producer_inn: (i%6==0) ? "1" :
            (i%6==1) ? "2" :
                (i%6==2) ? "3" :
                    (i%6==3) ? "4" :
                        (i%6==4) ? "5" :
                            "6" ,
        producer_kpp: (i%6==0) ? "1" :
            (i%6==1) ? "2" :
                (i%6==2) ? "3" :
                    (i%6==3) ? "4" :
                        (i%6==4) ? "5" :
                            "6" ,
        importer_name: (i%6==0) ? "ООО Атлант" :
            (i%6==1) ? "Ника" :
                (i%6==2) ? "Союз" :
                    (i%6==3) ? "Россия" :
                        (i%6==4) ? "Путинка" :
                            "Nemiroff" ,
        importer_id: i+1,
        importer_client_reg_id: (i%6==0) ? "1" :
            (i%6==1) ? "2" :
                (i%6==2) ? "3" :
                    (i%6==3) ? "4" :
                        (i%6==4) ? "5" :
                            "6" ,
        importer_inn: (i%6==0) ? "1" :
            (i%6==1) ? "2" :
                (i%6==2) ? "3" :
                    (i%6==3) ? "4" :
                        (i%6==4) ? "5" :
                            "6" ,
        importer_kpp: (i%6==0) ? "1" :
            (i%6==1) ? "2" :
                (i%6==2) ? "3" :
                    (i%6==3) ? "4" :
                        (i%6==4) ? "5" :
                            "6" ,
        alc_code: "743829563486583",
        ean: "12032021",
        user_rec: i%2==0 ? 1 : 0
    });

//--------------------------------------------------------------
//                            ***
//--------------------------------------------------------------
var showProductsListView = function(){
    var view = new kendo.View($('#productsListViewTemplate').html());
    layout.showIn("#content", view);
    kendo.culture("ru-RU");

    $("#refreshButton").kendoButton({
        icon: "refresh",
        click: function(){
            reloadPersonsList();
        }
    });

    var jsondataPersons = [];
    for (var i = 0; i < 20; i++)
        jsondataPersons.push({
            id: i+1,
            client_reg_id: (i%6==0) ? "1" :
                (i%6==1) ? "2" :
                    (i%6==2) ? "3" :
                        (i%6==3) ? "4" :
                            (i%6==4) ? "5" :
                                "6" ,
            name: (i%6==0) ? "ООО Атлант" :
                (i%6==1) ? "Ника" :
                    (i%6==2) ? "Союз" :
                        (i%6==3) ? "Россия" :
                            (i%6==4) ? "Путинка" :
                                "Nemiroff" ,
            inn: (i%6==0) ? "1" :
                (i%6==1) ? "2" :
                    (i%6==2) ? "3" :
                        (i%6==3) ? "4" :
                            (i%6==4) ? "5" :
                                "6" ,
            kpp: (i%6==0) ? "1" :
                (i%6==1) ? "2" :
                    (i%6==2) ? "3" :
                        (i%6==3) ? "4" :
                            (i%6==4) ? "5" :
                                "6" ,
            address: (i % 4 == 0) ? "Россия, 85503, Курская область, г. Курск, ул. Гайдара, 18" :
                (i % 4 == 1) ? "Россия, 85503, Курская область, г. Курск, ул. Ленина, 18" :
                    (i % 4 == 2) ? "Россия, 85503, Курская область, г. Курск, ул. Радищева, 18" :
                        "Россия, 85503, Курская область, г. Курск, ул. Московская, 18"
        });

    DATA_PERSONS = [];

    $("#productsListGrid").kendoGrid({
        dataSource  : {
            data: [],
            schema: {
                model: {
                    id: "id",
                    fields: {
                        id: { editable: false, nullable: true },
                        name: {},
                        capacity: {type: "number", validation: { min: 0 }},
                        alc_code: {},
                        product_v_code: {},
//                        name: { validation: {
//                            required: { message: "Введите наименование" }}
//                        },
//                        capacity: { validation: {
//                            required: { message: "Укажите объем" }}
//                        },
//                        alc_code: { validation: {
//                            required: { message: "Введите код ЕГАИС" }}
//                        },
//                        product_v_code: { validation: {
//                            required: { message: "Введите группу" }}
//                        },
                        producer_name: {},
                        importer_name: {defaultValue: "[Пусто]"},
                        importer_id: {editable: false, defaultValue: -1},
                        ean: {},
                        user_rec: {editable: false, defaultValue: 1},
                        command_product: { editable: false }
                    }
                }
            }
        },
        filterable: {
            extra: false,
            messages: {
                and: "и",
                or: "или",
                filter: "Фильтр",
                clear: "Очистить",
                info: "Фильтр по значению:",
                selectedItemsFormat: "Выбрано {0} элементов",
                checkAll: "Выбрать Всё"
            },
            operators: {
                string: {
                    contains: "Содержит",
                    eq: "Равно",
                    neq: "Не равно",
                    doesnotcontain: "Не содержит",
                    startswith: "Начинается на",
                    endswith: "Заканчивается на",
                    isempty: "Пустые",
                    isnotempty: "Не пустые"
                },
                number: {
                    eq: "=",
                    neq: "!=",
                    gt: ">",
                    lt: "<",
                    gte: ">=",
                    lte: "<=",
                    isnull: "Null",
                    isnotnull: "!Null"
                },
                date: {
                    gte: "после или равна",
                    gt: "после",
                    lte: "до или равна",
                    lt: "до"
                }
            }
        },
        resizable: true,
        reorderable: true,
        sortable: true,
        selectable: "row",
        pageable: {
            pageSize: 20,
            pageSizes: true
        },
        editable: {
            mode: "popup",
            confirmation: false
        },
        toolbar: [
            { template: '<span>Найти:</span>&nbsp;'+
                '<input name="base" id="inpSearch" class="k-textbox" style="height: auto;" onkeyup="toolbar_filter_keyup()");">'+
                '<button id="btnClean" type="button" style="margin-top: -0.4em !important;" class="k-button k-button-toolbar" title="Очистить" onclick="toolbar_clean_click()">'+
                    '<span class="k-icon k-i-arrowhead-w"></span>'+
                '</button>'+

                '<button type="button" id="btnAdd" class="k-button k-button-toolbar pull-right" title="Добавить" onclick="toolbar_add_click()">'+
                '<img class="k-image" width="16" height="16" src="assets/icons/pays/' + ADD_ICON + '"/>'+
                '</button>'
            }
        ],
        columns: [
            { field: "name", title: "Наименование", attributes:{ "class": "table-cell" }, width: 230, filterable: true },
            { field: "capacity", title: "Объем", width: 70, filterable: false,
                template: function(dataItem) {
                    return dataItem.capacity ? (dataItem.capacity + " л") : "";
                }
            },
            { field: "alc_code", title: "Код ЕГАИС", width: 180, filterable: true },
            { field: "product_v_code", title: "Группа", width: 70, filterable: false },
            { field: "producer_name", title: "Производитель", attributes:{ "class": "table-cell" }, width: 180, filterable: true,
                editor: function(container, options) {
                    var input = $('<input name="' + options.field + '" data-required-msg="Выберите производителя" required/>');
                    input.attr("name", options.field);
                    input.appendTo(container);

                    input.kendoDropDownList({
                        dataSource: DATA_PERSONS,
                        dataTextField: "name",
                        dataValueField: "name",
                        template: '<span>' +
                            '<b>Имя: </b> #: name #<br>' +
//                            '<b>ФСРАР ID: </b> #: clientRegId #<br>'+
                            '<b>ИНН: </b> #: inn #' +
                            '</span>',
                        filter: "contains"
                    });

                    var tooltipElement = $('<span class="k-invalid-msg" data-for="' + options.field + '"></span>');
                    tooltipElement.appendTo(container);
                }
            },
            { field: "importer_name", title: "Импортер", attributes:{ "class": "table-cell" }, width: 180, filterable: true,
                editor: function(container, options) {
                    var input = $("<input/>");
                    input.attr("name", options.field);
                    input.appendTo(container);

                    input.kendoDropDownList({
                        dataSource: DATA_PERSONS,
                        dataTextField: "name",
                        dataValueField: "name",
                        optionLabel: {
                            name: "[Пусто]"
                        },
                        template: '<span>' +
                            '<b>Имя: </b> #: name #<br>' +
//                            '<b>ФСРАР ID: </b> #: clientRegId #<br>'+
                            '<b>ИНН: </b> #: inn #' +
                            '</span>',
                        filter: "contains"
                    });
                }
            },
            { field: "ean", title: "Штрихкод", width: 110, filterable: true },
            {
                field: "command_product",
                template: function(dataItem) {
                    return (dataItem.user_rec == 1) ?
                        ('<button type="button" class="btn-grid-edit k-button" title="Редактировать" onclick="edit_click(this)">'+
                            '<img class="k-image" width="16" height="16" src="assets/icons/pays/' + EDIT_ICON + '"/>'+
                        '</button>'+
                        '<button type="button" class="btn-grid-del k-button" title="Удалить" onclick="del_click(this)">'+
                        '<img class="k-image" width="16" height="16" src="assets/icons/pays/' + DEL_ICON + '"/>'+
                        '</button>') : '';
                },
                title: "Команда", width: 80, filterable: false, sortable: false,
                headerTemplate: ""
            }
        ],
        edit: function(e) {
            if(isCreating) {
                e.container.kendoWindow("title", "Добавление товара");
                isCreating = false;
            } else {
                e.container.kendoWindow("title", "Редактирование товара");
            }

            e.container.find(".k-edit-label:last").hide();
            e.container.find(".k-edit-field:last").hide();

//            producer
            var dropdownlistProd = e.container.find("input[name=producer_name]").data("kendoDropDownList");

            dropdownlistProd.select(function (dataItem) {
                return dataItem.id === e.model.producer_id;
            });

            dropdownlistProd.bind("select", function (event) {
                var item = event.item;
                var dataItem = this.dataItem(item.index());

                e.model.producer_id = dataItem.id;
                e.model.producer_client_reg_id = dataItem.client_reg_id;
                e.model.producer_inn = dataItem.inn;
                e.model.producer_kpp = dataItem.kpp;
            });

//            importer
            var dropdownlistImp = e.container.find("input[name=importer_name]").data("kendoDropDownList");

            dropdownlistImp.select(function (dataItem) {
                return dataItem.id === e.model.importer_id;
            });

            dropdownlistImp.bind("select", function (event) {
                var item = event.item;
                var text = item.text();
                if(text === "[Пусто]") {
                    e.model.importer_id = -1;
                    return;
                }

                var dataItem = this.dataItem(item.index()+1);

                e.model.importer_id = dataItem.id;
                e.model.importer_client_reg_id = dataItem.client_reg_id;
                e.model.importer_inn = dataItem.inn;
                e.model.importer_kpp = dataItem.kpp;
            });
        },
        save: function(e) {
            updateProduct(parseDataUpdateProduct(e.model));
        }
    }).data("kendoGrid");

    bindWinSet('#productsList', "#productsListGrid", "cookieProductsList");

    $("#productsListGrid").kendoTooltip({
        filter: "td.table-cell:not(:empty)",
        position: "right",
        animation: {
            open: {
                effects: "fade:in",
                duration: 200
            }
        },
        showAfter: 400,
        content: function(e) {
            var target = e.target;
            var content = target.text();
            return content;
        }
    }).data("kendoTooltip");

    $("#productsListGrid").kendoTooltip({
        filter: ".k-button-toolbar, .btn-grid-edit, .btn-grid-del",
        callout: false,
        position: "top"
    });
//    reloadProductsList();
    reloadPersonsList();

    function reloadPersonsList(){
        try {
            channel.objects.utm_server.getPersons(function (result) {
                if(result.code == 0) {
                    DATA_PERSONS = result.data;
                    reloadProductsList();
                }
                else {
                    showErrorMessage(result.message);
                }
            });
        } catch(e) {
            showErrorMessage("Не удалось загрузить список контрагентов.");
        }
    }
}

function updateProduct(data){
//    console.log(JSON.stringify(data));
    try {
        channel.objects.utm_server.updateProduct(data, function (response) {
            hideAlerts();

            if(response.code == 0) {
                reloadProductsList();
            }
            else {
                showErrorMessage(response.message);
            }
        });
    } catch(e) {
        showErrorAlert("<strong>Соединение потеряно или истекло время сессии, попробуйте обновить страницу</strong>");
    }
}

function parseData(srcData) {
    var result = srcData;
    for (var i = 0; i < result.length; i++) {
        result[i].capacity = result[i].capacity / 1000;
    }
    return result;
}

function parseDataUpdateProduct(data){
    var importer;
    if(data.importer_id === -1) {
        importer = null;
    } else {
        importer = {
            inn: data.importer_inn,
            kpp: data.importer_kpp,
            clientRegId: data.importer_client_reg_id,
            fullName: data.importer_name,
            shortName: data.importer_name
        };
    }

    var result = {
        id: data.id == undefined ? -1 : data.id,
        producer: {
            inn: data.producer_inn,
            kpp: data.producer_kpp,
            clientRegId: data.producer_client_reg_id,
            fullName: data.producer_name,
            shortName: data.producer_name
        },
        importer: importer,
        name: data.name,
        capacity: data.capacity * 1000,
        egaisCode: data.alc_code,
        productCode: data.product_v_code,
        ean: data.ean,
        userRec: true
    };

    return result;
}