var DATA_SOURCE_PARAM_VALUES;
var LIST_VALUES_FOR_PARAM;
var paramNameAp;

var showQueryApView = function(){
    var view = new kendo.View($('#queryApFormViewTemplate').html());
    layout.showIn("#content", view);
    kendo.culture("ru-RU");

    var DEL_ICON = "delete.png",
        ADD_ICON = "plus-icon.png";

    LIST_VALUES_FOR_PARAM = {
        'КОД': [],
        'PDF': []
    };

    selectedTerminalId = "";
    paramNameAp = "КОД";

    $('#listParamAp').on('change', 'input[type="radio"]', function(){
        paramNameAp = this.value;

        DATA_SOURCE_PARAM_VALUES.data(LIST_VALUES_FOR_PARAM[paramNameAp]);
        if(paramNameAp == "КОД") {
            $("#paramValuesGrid thead th[data-field=name]").html("Код ЕГАИС")
        } else if (paramNameAp == "PDF") {
            $("#paramValuesGrid thead th[data-field=name]").html("Штрихкод")
        }
    });

    var validatable = $("#queryApForm").kendoValidator({
        validateOnBlur: false,
        messages: {
            required: function(input){
                return input.data("message");
            }
        },
        validate: function (e) {
            if (e.valid) {
                queryAp();
            }
            else {
                showWarningMessage("Не заполнены обязательные поля.");
            }
        }
    }).data("kendoValidator");

    $("#btnQueryApAccept").kendoButton({
        icon : "tick",
        click: function(e) {
            validatable.validate();
        }
    });

    DATA_SOURCE_PARAM_VALUES = new kendo.data.DataSource({
        data: [],
        schema: {
            model: {
                fields: {

                }
            }
        }
    });

    var paramValuesGrid = $("#paramValuesGrid").kendoGrid({
        dataSource: DATA_SOURCE_PARAM_VALUES,
        filterable: false,
        resizable: true,
        sortable: false,
        height: 400,
        selectable: "multiple, row",
        toolbar: [
            { template: kendo.template($("#toolbarParamValuesGrid").html()) }
        ],
        columns: [
            { field: "identity", title: "№", width: 40, filterable: false,
                template: function(dataItem){
                    var ds = $("#paramValuesGrid").data("kendoGrid").dataSource,
                        index = ds.indexOf( dataItem );
                    return index + 1;
                }
            },
            { field: "name", title: "Код ЕГАИС", width: 230 }
        ],
        dataBound: function(){
            var data = $("#paramValuesGrid").data("kendoGrid").dataSource.data();
            LIST_VALUES_FOR_PARAM[paramNameAp] = data;
        }
    }).data("kendoGrid");

    $('#btnAddStamp').kendoButton({
        imageUrl: "assets/icons/pays/" + ADD_ICON,
        click: function() {
            showEnterParamsDialogView();
        }
    });
    $('#btnDelStamp').kendoButton({
        imageUrl: "assets/icons/pays/" + DEL_ICON,
        click: function() {
            var grid = $("#paramValuesGrid").data("kendoGrid");
            var selectedRows = grid.select();
            for (var i = 0; i < selectedRows.length; i++) {
                grid.removeRow(selectedRows[i]);
            }
        }
    });
}

var showEnterParamsDialogView = function() {
    var selectedItem;
    dialogEnterStamps.content( kendo.template($("#wrapDialogEnterStamps").html()) );
    dialogEnterStamps.center().open();

    var title = (paramNameAp == "КОД") ? "Вводите алкокоды с клавиатуры:" :
        "Сканируйте штрихкоды или вводите с клавиатуры:"

    var viewModelDialogInfoFormA = kendo.observable({
        titleEnterField: title,
        cancel: function() {
            dialogEnterStamps.close();
        }
    });
    kendo.bind($("#dialogEnterStamps"), viewModelDialogInfoFormA);

    $("#inpStamps").focus();

    $("#enterStamps").kendoButton({
        icon: "arrowhead-e"
    });

    $("#formStamps").on('submit', function(){
        var val = $("#inpStamps").val();

        DATA_SOURCE_PARAM_VALUES.insert(0, { name: val });
        $("#inpStamps").val("").focus();

        return false;
    });
}

var queryAp = function() {
    var values = [];
    var dataValues = LIST_VALUES_FOR_PARAM[paramNameAp];

    for (var i = 0; i < dataValues.length; i++) {
        values.push(dataValues[i].name);
    }

    var newCommand = {
        paramName: paramNameAp,
        paramValues: values
    };

    showProcessAlert("Отправка запроса на получение номенклатуры");
    clearInterval(timerId);
    timerId = dotted();

    try {
        channel.objects.utm_server.queryAp(newCommand, function (res) {
            hideAlerts();
            clearInterval(timerId);

            if(res.code == 0) {
                showSuccessMessage("Запрос на получение номенклатуры успешно отправлен.");
            } else {
                showErrorMessage(res.message);
            }
        });
    } catch (e) {
        showErrorAlert("<strong>При отправке запроса произошла ошибка, попробуйте обновить страницу.</strong>");
        clearInterval(timerId);
    }
}