var dialogQueryPartner;
var paramName;

$(window).load(function() {
    dialogQueryPartner = $("#dialogQueryPartner").kendoWindow({
        actions: [ "Close" ],
        title: "Запрос контрагента",
        visible: false,
        resizable: false,
        scrollable: false,
        modal: true,
        pinned: true,
        width: 500
    }).data("kendoWindow");

    $('#dialogQueryPartner').keydown(function(eventObject){
        if(eventObject.which == '27')
            dialogQueryPartner.close();
    });

    $(window).resize(function(){
        var width;

        if (window.innerWidth < '768') {
            width = 280;
        } else {
            width = 500;
        }

        dialogQueryPartner.setOptions({
            width: width
        });
        dialogQueryPartner.center();
    });
    $(window).resize();
});

var showQueryPartnerDialog = function () {
    dialogQueryPartner.content( kendo.template($("#contentDialogQueryPartnerTemplate").html()) );
    dialogQueryPartner.center().open();

    var selectedTerminalId;
    paramName = "ИНН";

    $('#inputInn').inputmask("Regex");

    var viewModel = kendo.observable({
        isVisibleInn: true,
        isVisibleSio: false
    });
    kendo.bind($("#formQueryPartner"), viewModel);

    $('#listParamPartner').on('change', 'input[type="radio"]', function(){
        var value = this.value;
        paramName = value;

        if(value == "ИНН") {
            viewModel.set("isVisibleInn", true);
            viewModel.set("isVisibleSio", false);
        } else if (value == "СИО") {
            viewModel.set("isVisibleInn", false);
            viewModel.set("isVisibleSio", true);
        }
    });

    $("#formQueryPartner #send").kendoButton({
        icon : "tick",
        click: function(e) {
            queryPartner();
        }
    });
    $("#formQueryPartner #cancel").kendoButton({
        click: function(e) {
            dialogQueryPartner.close();
        }
    });


    var validatableQueryPartner = $("#formQueryPartner").kendoValidator({
        validateOnBlur: false,
        messages: {
            innRule: "Длина ИНН должна быть 10 или 12 символов",
            innFormatRule: "Неверная контрольная сумма ИНН",
            required: function(input){
                return input.data("message");
            }
        },
        rules: {
            innRule: function(input) {
                if (input.is("[name=inn]")) {
                    return (input.val().length == 10 || input.val().length == 12);
                }
                return true;
            },
            innFormatRule: function(input) {
                if (input.is("[name=inn]")) {
                    return is_valid_inn(input.val());
                }
                return true;
            }
        }
    }).data("kendoValidator");

    var queryPartner = function() {
        var validField = false;
        if(paramName == "ИНН") {
            validField = validatableQueryPartner.validateInput($("input[name=inn]"));
        } else if (paramName == "СИО") {
            validField = validatableQueryPartner.validateInput($("input[name=sio]"));
        }
        if (validField) {
            var paramValue = (paramName == "ИНН") ? $("#formQueryPartner #inputInn").val() :
                (paramName == "СИО") ? $("#formQueryPartner #inputSio").val() : "";
            var queryAPValue = $('#cbQueryAP').prop("checked") ? 1 : 0;

            var newCommand =  {
                paramName: paramName,
                paramValue: paramValue,
                queryAP: queryAPValue
            };

            try {
                channel.objects.utm_server.queryPartner(newCommand, function (res) {
                    if(res.code == 0) {
                        showSuccessMessage("Запрос на получение контрагента успешно отправлен.");
                    } else {
                        showErrorMessage(res.message);
                    }
                    dialogQueryPartner.close();
                });
            } catch (e) {
                showErrorMessage("При отправке запроса произошла ошибка, попробуйте обновить страницу.");
                dialogQueryPartner.close();
            }
        }
    }
};